#include "common.h"
#include "config.h"
//#include "../const.h"
#include "../FileListWindow/dirtree.h"	//FILEINFO_TYPE
#include "../resource.h"
#include "../ArchiverCode/arc_interface.h"

CConfigManager::CConfigManager()
{
	TRACE(_T("CConfigManager()\n"));
	//---CaldixINIt@C
	TCHAR szIniPath[_MAX_PATH+1]={0};
	_tcsncpy_s(szIniPath,UtilGetModuleDirectoryPath(),_MAX_PATH);
	PathAppend(szIniPath,CALDIX_INI_FILE_NAME);
	if(PathFileExists(szIniPath)){
		//LhaForgetH_ƓꏊINIΎgp
		m_strCaldixIniPath=szIniPath;
	}else{
		//CSIDL_COMMON_APPDATAINIpӂAgp
		SHGetFolderPath(NULL,CSIDL_COMMON_APPDATA|CSIDL_FLAG_CREATE,NULL,SHGFP_TYPE_CURRENT,szIniPath);
		PathAppend(szIniPath,PROGRAMDIR_NAME);
		PathAddBackslash(szIniPath);
		UtilMakeSureDirectoryPathExists(szIniPath);
		PathAppend(szIniPath,CALDIX_INI_FILE_NAME);
		m_strCaldixIniPath=szIniPath;
	}

	//---LhaForge.ini/LFCaldix.inȉꏊ
	UtilGetDefaultFilePath(m_strIniPath,PROGRAMDIR_NAME,INI_FILE_NAME,m_bUserCommon);

//==================
// ftHglݒ
//==================
	// Common
	FILL_ZERO(Common);
	// OpenAction
	FILL_ZERO(OpenAction);
	// ShellExt
	FILL_ZERO(ShellExt);
	// Update
	FILL_ZERO(Update);
	// t@CXgEBhE̐ݒ̏
//	FILL_ZERO(FileListWindow);
	// LZH
	FILL_ZERO(LZH);
	// ZIP
	FILL_ZERO(ZIP);
	// CAB
	FILL_ZERO(CAB);
	// 7z
	FILL_ZERO(SEVEN_ZIP);
	// TAR
	FILL_ZERO(TAR);
	// JACK
	FILL_ZERO(JACK);
	// HKI
	FILL_ZERO(HKI);
	// BGA
	FILL_ZERO(BGA);
	// ISH
	FILL_ZERO(AISH);
	// B2E
//	FILL_ZERO(B2E);
}

CConfigManager::~CConfigManager()
{
}


void CConfigManager::SetConfigFile(LPCTSTR lpszFile)
{
	if(!lpszFile){
		//NULLnꂽftHgݒ
		UtilGetDefaultFilePath(m_strIniPath,PROGRAMDIR_NAME,INI_FILE_NAME,m_bUserCommon);
		return;
	}
	m_bUserCommon=false;
	UtilGetAbsPathName(m_strIniPath,lpszFile);
	TRACE(_T("Custom Config Path=%s\n"),m_strIniPath);
}

bool CConfigManager::LoadConfig(CONFIG_TYPE type)
{
	TCHAR Buffer[_MAX_PATH+1];
	FILL_ZERO(Buffer);
	LPCTSTR SectionName=NULL;
	switch(type){
	case CONFIG_COMMON:	//ʐݒ
	//==============
	// ko͐ݒ
	//==============
		SectionName=_T("Compress");
		//o͐̎
		Common.Compress.OutputDirType=(COMPRESS_TO)GetPrivateProfileInt(SectionName,_T("OutputDirType"),COMPRESS_TO_DESKTOP,m_strIniPath);
		if(Common.Compress.OutputDirType<0||Common.Compress.OutputDirType>=COMPRESS_TO_MAX_NUM){
			Common.Compress.OutputDirType=COMPRESS_TO_DESKTOP;
		}
		//o͐̃pX
		GetPrivateProfileString(SectionName,_T("OutputDir"),_T(""),Buffer,_MAX_PATH,m_strIniPath);
		if(0<_tcslen(Buffer)){
			//_tfullpath(Common.Compress.OutputDir,Buffer,_MAX_PATH);
			//GetLongPathName(Common.Compress.OutputDir,Common.Compress.OutputDir,_MAX_PATH);
			CString strTemp;
			UtilGetCompletePathName(strTemp,Buffer);
			_tcsncpy_s(Common.Compress.OutputDir,strTemp,_MAX_PATH);
		}
		//ktH_Jǂ
		Common.Compress.OpenDir=GetPrivateProfileInt(SectionName,_T("OpenFolder"),TRUE,m_strIniPath);

		//o̓t@Cw肷邩ǂ
		Common.Compress.SpecifyOutputFilename=GetPrivateProfileInt(SectionName,_T("SpecifyName"),FALSE,m_strIniPath);

		//Ɉkt@C𐧌
		Common.Compress.LimitCompressFileCount=GetPrivateProfileInt(SectionName,_T("LimitCompressFileCount"),FALSE,m_strIniPath);

		//Ɉkt@C̏
		Common.Compress.MaxCompressFileCount=GetPrivateProfileInt(SectionName,_T("MaxCompressFileCount"),1,m_strIniPath);
		if(Common.Compress.MaxCompressFileCount<=0){
			Common.Compress.MaxCompressFileCount=1;
		}

		//ftHgkp[^gpȂtrue
		Common.Compress.UseDefaultParameter=GetPrivateProfileInt(SectionName,_T("UseDefaultParameter"),FALSE,m_strIniPath);

		//ftHgkp[^(`w)
		Common.Compress.DefaultType=(PARAMETER_TYPE)GetPrivateProfileInt(SectionName,_T("DefaultType"),PARAMETER_UNDEFINED,m_strIniPath);
		if(Common.Compress.DefaultType<0||Common.Compress.DefaultType>=PARAMETER_MAX_NUM){
			Common.Compress.DefaultType=PARAMETER_UNDEFINED;
		}

		//ftHgkp[^̃IvV
		Common.Compress.DefaultOptions=GetPrivateProfileInt(SectionName,_T("DefaultOptions"),0,m_strIniPath);

		//B2Ek̏
		GetPrivateProfileString(SectionName,_T("DefaultB2EFormat"),_T(""),Common.Compress.DefaultB2EFormat,sizeof(Common.Compress.DefaultB2EFormat)/sizeof(Common.Compress.DefaultB2EFormat[0])-1,m_strIniPath);
		GetPrivateProfileString(SectionName,_T("DefaultB2EMethod"),_T(""),Common.Compress.DefaultB2EMethod,sizeof(Common.Compress.DefaultB2EMethod)/sizeof(Common.Compress.DefaultB2EMethod[0])-1,m_strIniPath);

	//==============
	// 𓀏o͐ݒ
	//==============
		SectionName=_T("Extract");
		Common.Extract.OutputDirType=(EXTRACT_TO)GetPrivateProfileInt(SectionName,_T("OutputDirType"),EXTRACT_TO_DESKTOP,m_strIniPath);
		if(Common.Extract.OutputDirType<0||Common.Extract.OutputDirType>=EXTRACT_TO_MAX_NUM){
			Common.Extract.OutputDirType=EXTRACT_TO_DESKTOP;
		}

		GetPrivateProfileString(SectionName,_T("OutputDir"),_T(""),Buffer,_MAX_PATH,m_strIniPath);
		if(0<_tcslen(Buffer)){
			//_tfullpath(Common.Extract.OutputDir,Buffer,_MAX_PATH);
			//GetLongPathName(Common.Extract.OutputDir,Common.Extract.OutputDir,_MAX_PATH);
			CString strTemp;
			UtilGetCompletePathName(strTemp,Buffer);
			_tcsncpy_s(Common.Extract.OutputDir,strTemp,_MAX_PATH);
		}

		//𓀌tH_Jǂ
		Common.Extract.OpenDir=GetPrivateProfileInt(SectionName,_T("OpenFolder"),TRUE,m_strIniPath);

		//𓀎tH_dɂ邩ǂ
		Common.Extract.CreateDir=(CREATE_OUTPUT_DIR)GetPrivateProfileInt(SectionName,_T("CreateDir"),CREATE_OUTPUT_DIR_ALWAYS,m_strIniPath);
		if(Common.Extract.CreateDir<0||Common.Extract.CreateDir>=CREATE_OUTPUT_DIR_MAX_NUM){
			Common.Extract.CreateDir=CREATE_OUTPUT_DIR_ALWAYS;
		}

		//𓀎t@CmFɏ㏑邩ǂ
		Common.Extract.ForceOverwrite=GetPrivateProfileInt(SectionName,_T("ForceOverwrite"),FALSE,m_strIniPath);

		//𓀎tH_琔ƋL폜
		Common.Extract.RemoveSymbolAndNumber=GetPrivateProfileInt(SectionName,_T("RemoveSymbolAndNumber"),FALSE,m_strIniPath);

		//𓀎t@CEtH_̎tH_Ȃ
		Common.Extract.CreateNoFolderIfSingleFileOnly=GetPrivateProfileInt(SectionName,_T("CreateNoFolderIfSingleFileOnly"),FALSE,m_strIniPath);

		//ɉ𓀂t@C𐧌
		Common.Extract.LimitExtractFileCount=GetPrivateProfileInt(SectionName,_T("LimitExtractFileCount"),FALSE,m_strIniPath);

		//ɉ𓀂t@C̏
		Common.Extract.MaxExtractFileCount=GetPrivateProfileInt(SectionName,_T("MaxExtractFileCount"),1,m_strIniPath);
		if(Common.Extract.MaxExtractFileCount<=0){
			Common.Extract.MaxExtractFileCount=1;
		}

		//ɉ𓀂łkt@C폜
		Common.Extract.DeleteArchiveAfterExtract=GetPrivateProfileInt(SectionName,_T("DeleteArchiveAfterExtract"),FALSE,m_strIniPath);

		//𓀌t@CݔɈړ
		Common.Extract.MoveToRecycleBin=GetPrivateProfileInt(SectionName,_T("MoveToRecycleBin"),TRUE,m_strIniPath);

		//mFɃA[JCu폜/ݔɈړ
		Common.Extract.DeleteNoConfirm=GetPrivateProfileInt(SectionName,_T("DeleteNoConfirm"),FALSE,m_strIniPath);

		//𓀃G[młȂꍇ폜
		Common.Extract.ForceDelete=GetPrivateProfileInt(SectionName,_T("ForceDelete"),FALSE,m_strIniPath);

		//}`{[폜
		Common.Extract.DeleteMultiVolume=GetPrivateProfileInt(SectionName,_T("DeleteMultiVolume"),FALSE,m_strIniPath);
	//==============
	// o͈ʐݒ
	//==============
		SectionName=_T("Output");
		// o͐ނɑ΂x
		Common.WarnNetwork=GetPrivateProfileInt(SectionName,_T("WarnNetwork"),FALSE,m_strIniPath);

		Common.WarnRemovable=GetPrivateProfileInt(SectionName,_T("WarnRemovable"),FALSE,m_strIniPath);

		// o͐悪Ȃꍇ̐ݒ
		Common.OnDirNotFound=(LOSTDIR)GetPrivateProfileInt(SectionName,_T("OnDirNotFound"),0,m_strIniPath);
		if(Common.OnDirNotFound<0||Common.OnDirNotFound>=LOSTDIR_MAX_NUM){
			Common.OnDirNotFound=LOSTDIR_ERROR;
		}

	//==========================
	// O\^C~O
	//==========================
		SectionName=_T("LogView");
		Common.LogViewEvent=(LOGVIEW)GetPrivateProfileInt(SectionName,_T("LogViewEvent"),LOGVIEW_ON_ERROR,m_strIniPath);
		if(Common.LogViewEvent<0||Common.LogViewEvent>=LOGVIEW_MAX_NUM){
			Common.LogViewEvent=LOGVIEW_ON_ERROR;
		}

	//==============
	// t@Cݒ
	//==============
		SectionName=_T("Filer");
		Common.Filer.UseFiler=GetPrivateProfileInt(SectionName,_T("UseFiler"),FALSE,m_strIniPath);

		GetPrivateProfileString(SectionName,_T("FilerPath"),_T(""),Common.Filer.FilerPath,_MAX_PATH,m_strIniPath);
		if(0>=_tcslen(Common.Filer.FilerPath)){
			FILL_ZERO(Common.Filer.FilerPath);
		}

		GetPrivateProfileString(SectionName,_T("Param"),_T(""),Common.Filer.Param,_MAX_PATH,m_strIniPath);
		if(0>=_tcslen(Common.Filer.Param)){
			FILL_ZERO(Common.Filer.Param);
		}
		break;
	case CONFIG_OPENACTION:
	//==================
	// ֘Atݒ
	//==================
		SectionName=_T("OpenAction");
		//I
		OpenAction.OpenAction=(OPENACTION)GetPrivateProfileInt(SectionName,_T("OpenAction"),OPENACTION_EXTRACT,m_strIniPath);
		if(OpenAction.OpenAction<0||OpenAction.OpenAction>=OPENACTION_MAX_NUM){
			OpenAction.OpenAction=OPENACTION_EXTRACT;
		}
		OpenAction.OpenAction_Shift=(OPENACTION)GetPrivateProfileInt(SectionName,_T("OpenAction_Shift"),OPENACTION_LIST,m_strIniPath);
		if(OpenAction.OpenAction_Shift<0||OpenAction.OpenAction_Shift>=OPENACTION_MAX_NUM){
			OpenAction.OpenAction_Shift=OPENACTION_LIST;
		}
		OpenAction.OpenAction_Ctrl=(OPENACTION)GetPrivateProfileInt(SectionName,_T("OpenAction_Ctrl"),OPENACTION_TEST,m_strIniPath);
		if(OpenAction.OpenAction_Ctrl<0||OpenAction.OpenAction_Ctrl>=OPENACTION_MAX_NUM){
			OpenAction.OpenAction_Ctrl=OPENACTION_TEST;
		}
		break;
	case CONFIG_SHELL_EXT:	//VFgj[
	//==================================
	// ENbNj[̕\E\
	//==================================
		SectionName=_T("ShellMenu");
		ShellExt.ShellMenuCompress=GetPrivateProfileInt(SectionName,_T("Compress"),TRUE,m_strIniPath);

		ShellExt.ShellMenuExtract=GetPrivateProfileInt(SectionName,_T("Extract"),TRUE,m_strIniPath);

		ShellExt.ShellMenuList=GetPrivateProfileInt(SectionName,_T("List"),TRUE,m_strIniPath);

		ShellExt.ShellMenuTest=GetPrivateProfileInt(SectionName,_T("Test"),TRUE,m_strIniPath);

		// Tuj[ȉɕ荞
		ShellExt.ShellMenuUnderSubMenu=GetPrivateProfileInt(SectionName,_T("UnderSubMenu"),FALSE,m_strIniPath);
	//==================================
	// EhbOj[̕\E\
	//==================================
		SectionName=_T("DragMenu");
		ShellExt.DragMenuCompress=GetPrivateProfileInt(SectionName,_T("Compress"),TRUE,m_strIniPath);

		ShellExt.DragMenuExtract=GetPrivateProfileInt(SectionName,_T("Extract"),TRUE,m_strIniPath);
		// Tuj[ȉɕ荞
		ShellExt.DragMenuUnderSubMenu=GetPrivateProfileInt(SectionName,_T("UnderSubMenu"),FALSE,m_strIniPath);
	//====================
	// gj[̕\
	//====================
		SectionName=_T("ExtraMenu");
		ShellExt.ForceExtraMenu=GetPrivateProfileInt(SectionName,_T("ForceExtraMenu"),FALSE,m_strIniPath);
	//============================
	// JX^}CYj[̎gp
	//============================
		SectionName=_T("CustomMenu");
		ShellExt.UseCustomMenu=GetPrivateProfileInt(SectionName,_T("UseCustom"),FALSE,m_strIniPath);
		break;
	case CONFIG_UPDATE:
	//================
	// XVmF𑣂
	//================
		SectionName=_T("Update");
		Update.AskUpdate=GetPrivateProfileInt(SectionName,_T("AskUpdate"),TRUE,m_strIniPath);

		Update.Interval=GetPrivateProfileInt(SectionName,_T("Interval"),21,m_strIniPath);

		//ŏIXV̍XVLFCaldixɔC
		Update.LastTime=(time_t)GetPrivateProfileInt(SectionName,_T("LastTime"),0,m_strCaldixIniPath);
		//[U[pt@Cɏ܂ꂽŏIXV`FbN
		Update.LastTime=max(Update.LastTime,(time_t)GetPrivateProfileInt(SectionName,_T("LastTime"),0,m_strIniPath));

		//CXg[̎擾
		SectionName=_T("conf");
		GetPrivateProfileString(SectionName,_T("dll"),_T(""),Update.szDLLPath,_MAX_PATH,m_strCaldixIniPath);
		break;
	case CONFIG_LZH:
	//=============
	// LZHkݒ
	//=============
		SectionName=_T("LZH");
		//k`
		LZH.CompressType=(LZH_COMPRESS_TYPE)GetPrivateProfileInt(SectionName,_T("CompressType"),0,m_strIniPath);
		if(LZH.CompressType<0||LZH.CompressType>=LZH_COMPRESS_TYPE_MAX_NUM){
			LZH.CompressType=(LZH_COMPRESS_TYPE)0;
		}
		//SFX̐ݒsǂ
		LZH.ConfigSFX=GetPrivateProfileInt(SectionName,_T("ConfigSFX"),0,m_strIniPath);
		break;
	case CONFIG_ZIP:
	//=============
	// ZIPkݒ
	//=============
		SectionName=_T("ZIP");
		//k`
		ZIP.CompressType=(ZIP_COMPRESS_TYPE)GetPrivateProfileInt(SectionName,_T("CompressType"),0,m_strIniPath);
		if(ZIP.CompressType<0||ZIP.CompressType>=ZIP_COMPRESS_TYPE_MAX_NUM){
			ZIP.CompressType=(ZIP_COMPRESS_TYPE)0;
		}
		//kx
		ZIP.CompressLevel=(ZIP_COMPRESS_LEVEL)GetPrivateProfileInt(SectionName,_T("CompressLevel"),0,m_strIniPath);
		if(ZIP.CompressLevel<0||ZIP.CompressLevel>=ZIP_COMPRESS_LEVEL_MAX_NUM){
			ZIP.CompressLevel=(ZIP_COMPRESS_LEVEL)0;
		}
		//pX[h֘A
		{
			//w肳ꂽpX[hgǂ
			int Use=GetPrivateProfileInt(SectionName,_T("UseFixedPassword"),0,m_strIniPath);
			//pX[h̕
			int Length=GetPrivateProfileInt(SectionName,_T("PasswordLength"),0,m_strIniPath);
			GetPrivateProfileString(SectionName,_T("Password"),_T(""),Buffer,_MAX_PATH,m_strIniPath);
			if(0!=Use||0!=Length||0!=_tcslen(Buffer)){
				CString msg;
				msg.Format(IDS_PASSWORD_CANT_SAVE,SectionName);
				if(IDYES==MessageBox(NULL,msg,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
					WritePrivateProfileString(SectionName,_T("UseFixedPassword"),_T("0"),m_strIniPath);
					WritePrivateProfileString(SectionName,_T("PasswordLength"),_T("0"),m_strIniPath);
					WritePrivateProfileString(SectionName,_T("Password"),_T(""),m_strIniPath);
				}
			}
		}
		//㋉ݒ
		//D悷郁̃oCgw肷邩ǂ
		ZIP.SpecifyDeflateMemorySize=GetPrivateProfileInt(SectionName,_T("SpecifyDeflateMemorySize"),FALSE,m_strIniPath);
		//D悷郁̃oCg
		ZIP.DeflateMemorySize=GetPrivateProfileInt(SectionName,_T("DeflateMemorySize"),32,m_strIniPath);
		if(ZIP.DeflateMemorySize<ZIP_DEFLATE_MEMORY_SIZE_LOWEST||ZIP.DeflateMemorySize>ZIP_DEFLATE_MEMORY_SIZE_HIGHEST){
			ZIP.DeflateMemorySize=32;
		}
		//GR[_̃pXw肷邩ǂ
		ZIP.SpecifyDeflatePassNumber=GetPrivateProfileInt(SectionName,_T("SpecifyDeflatePassNumber"),FALSE,m_strIniPath);
		//GR[_̃pX
		ZIP.DeflatePassNumber=GetPrivateProfileInt(SectionName,_T("DeflatePassNumber"),1,m_strIniPath);
		if(ZIP.DeflatePassNumber<ZIP_DEFLATE_PASS_NUMBER_LOWEST||ZIP.DeflatePassNumber>ZIP_DEFLATE_PASS_NUMBER_HIGHEST){
			ZIP.DeflatePassNumber=1;
		}
		break;
	case CONFIG_CAB:
	//=============
	// CABkݒ
	//=============
		SectionName=_T("CAB");
		//k`
		CAB.CompressType=(CAB_COMPRESS_TYPE)GetPrivateProfileInt(SectionName,_T("CompressType"),0,m_strIniPath);
		if(CAB.CompressType<0||CAB.CompressType>=CAB_COMPRESS_TYPE_MAX_NUM){
			CAB.CompressType=(CAB_COMPRESS_TYPE)0;
		}
		//LZXk̃x
		CAB.LZX_Level=GetPrivateProfileInt(SectionName,_T("LZXLevel"),0,m_strIniPath);
		if(CAB.LZX_Level<CAB_LZX_LOWEST||CAB.LZX_Level>CAB_LZX_HIGHEST){
			CAB.LZX_Level=CAB_LZX_LOWEST;
		}
		break;
	case CONFIG_7Z:
	//============
	// 7zkݒ
	//============
		SectionName=_T("7Z");
		//vZbggǂ
		SEVEN_ZIP.UsePreset=GetPrivateProfileInt(SectionName,_T("UsePreset"),TRUE,m_strIniPath);
		//k`
		SEVEN_ZIP.CompressType=(SEVEN_ZIP_COMPRESS_TYPE)GetPrivateProfileInt(SectionName,_T("CompressType"),0,m_strIniPath);
		if(SEVEN_ZIP.CompressType<0||SEVEN_ZIP.CompressType>=SEVEN_ZIP_COMPRESS_TYPE_MAX_NUM){
			SEVEN_ZIP.CompressType=(SEVEN_ZIP_COMPRESS_TYPE)0;
		}
		//kx
		SEVEN_ZIP.CompressLevel=(SEVEN_ZIP_COMPRESS_LEVEL)GetPrivateProfileInt(SectionName,_T("CompressLevel"),0,m_strIniPath);
		if(SEVEN_ZIP.CompressLevel<0||SEVEN_ZIP.CompressLevel>=SEVEN_ZIP_COMPRESS_LEVEL_MAX_NUM){
			SEVEN_ZIP.CompressLevel=(SEVEN_ZIP_COMPRESS_LEVEL)0;
		}
		//LZMAk[h
		SEVEN_ZIP.LZMA_Mode=(SEVEN_ZIP_LZMA_MODE)GetPrivateProfileInt(SectionName,_T("LZMAMode"),0,m_strIniPath);
		if(SEVEN_ZIP.LZMA_Mode<0||SEVEN_ZIP.LZMA_Mode>=SEVEN_ZIP_LZMA_MODE_MAX_NUM){
			SEVEN_ZIP.LZMA_Mode=(SEVEN_ZIP_LZMA_MODE)0;
		}
		//\bhk
		SEVEN_ZIP.SolidMode=GetPrivateProfileInt(SectionName,_T("SolidMode"),TRUE,m_strIniPath);
		//wb_k
		SEVEN_ZIP.HeaderCompression=GetPrivateProfileInt(SectionName,_T("HeaderCompression"),TRUE,m_strIniPath);
		//wb_Sk
		SEVEN_ZIP.FullHeaderCompression=GetPrivateProfileInt(SectionName,_T("HeaderFullCompression"),TRUE,m_strIniPath);
		//wb_Í
		SEVEN_ZIP.HeaderEncryption=GetPrivateProfileInt(SectionName,_T("HeaderEncryption"),FALSE,m_strIniPath);
		//-------------------------------------------------
		// pX[h֘A;݂̓pX[hpR[ĥ
		//-------------------------------------------------
		{
			//w肳ꂽpX[hgǂ
			int Use=GetPrivateProfileInt(SectionName,_T("UseFixedPassword"),FALSE,m_strIniPath);
			//pX[h̕
			int Length=GetPrivateProfileInt(SectionName,_T("PasswordLength"),0,m_strIniPath);
			GetPrivateProfileString(SectionName,_T("Password"),_T(""),Buffer,_MAX_PATH,m_strIniPath);
			if(0!=Use||0!=Length||0!=_tcslen(Buffer)){
				CString msg;
				msg.Format(IDS_PASSWORD_CANT_SAVE,SectionName);
				if(IDYES==MessageBox(NULL,msg,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
					WritePrivateProfileString(SectionName,_T("UseFixedPassword"),_T("0"),m_strIniPath);
					WritePrivateProfileString(SectionName,_T("PasswordLength"),_T("0"),m_strIniPath);
					WritePrivateProfileString(SectionName,_T("Password"),_T(""),m_strIniPath);
				}
			}
		}
		//㋉ݒ
		//PPMd̃fTCYw肷邩ǂ
		SEVEN_ZIP.SpecifyPPMdModelSize=GetPrivateProfileInt(SectionName,_T("SpecifyPPMdModelSize"),FALSE,m_strIniPath);
		//PPMd̃fTCY
		SEVEN_ZIP.PPMdModelSize=GetPrivateProfileInt(SectionName,_T("PPMdModelSize"),6,m_strIniPath);
		if(SEVEN_ZIP.PPMdModelSize<SEVEN_ZIP_PPMD_MODEL_SIZE_LOWEST||SEVEN_ZIP.PPMdModelSize>ZIP_DEFLATE_MEMORY_SIZE_HIGHEST){
			SEVEN_ZIP.PPMdModelSize=6;
		}
		break;
	case CONFIG_TAR:
	//====================
	// TAR/GZ/BZ2kݒ
	//====================
		SectionName=_T("TAR");
		//GZIP̈kx
		TAR.GzipCompressLevel=GetPrivateProfileInt(SectionName,_T("GZIPLevel"),6,m_strIniPath);
		if(TAR.GzipCompressLevel<GZIP_COMPRESS_LEVEL_LOWEST||TAR.GzipCompressLevel>GZIP_COMPRESS_LEVEL_HIGHEST){
			TAR.GzipCompressLevel=6;
		}
		//BZIP2̈kx
		TAR.Bzip2CompressLevel=GetPrivateProfileInt(SectionName,_T("BZIP2Level"),9,m_strIniPath);
		if(TAR.Bzip2CompressLevel<BZIP2_COMPRESS_LEVEL_LOWEST||TAR.Bzip2CompressLevel>BZIP2_COMPRESS_LEVEL_HIGHEST){
			TAR.Bzip2CompressLevel=9;
		}
		break;
	case CONFIG_JACK:
	//==============
	// JACKkݒ
	//==============
		SectionName=_T("JACK");
		JACK.SpecifyVolumeSizeAtCompress=GetPrivateProfileInt(SectionName,_T("SpecifyAtCompress"),TRUE,m_strIniPath);
		JACK.VolumeSize=GetPrivateProfileInt(SectionName,_T("VolumeSize"),1423,m_strIniPath);
		if(JACK.VolumeSize<=0){
			JACK.VolumeSize=1423;
		}
		break;
	case CONFIG_BH:
	//============
	// BHkݒ
	//============
		SectionName=_T("BH");
		{
			//w肳ꂽpX[hgǂ
			int Use=GetPrivateProfileInt(SectionName,_T("UseFixedPassword"),FALSE,m_strIniPath);
			//pX[h̕
			int Length=GetPrivateProfileInt(SectionName,_T("PasswordLength"),0,m_strIniPath);
			GetPrivateProfileString(SectionName,_T("Password"),_T(""),Buffer,_MAX_PATH,m_strIniPath);
			if(0!=Use||0!=Length||0!=_tcslen(Buffer)){
				CString msg;
				msg.Format(IDS_PASSWORD_CANT_SAVE,SectionName);
				if(IDYES==MessageBox(NULL,msg,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
					WritePrivateProfileString(SectionName,_T("UseFixedPassword"),_T("0"),m_strIniPath);
					WritePrivateProfileString(SectionName,_T("PasswordLength"),_T("0"),m_strIniPath);
					WritePrivateProfileString(SectionName,_T("Password"),_T(""),m_strIniPath);
				}
			}
		}
		break;
	case CONFIG_YZ1:
	//=============
	// YZ1kݒ
	//=============
		SectionName=_T("YZ1");
		//pX[h֘A
		{
			//w肳ꂽpX[hgǂ
			int Use=GetPrivateProfileInt(SectionName,_T("UseFixedPassword"),FALSE,m_strIniPath);
			//pX[h̕
			int Length=GetPrivateProfileInt(SectionName,_T("PasswordLength"),0,m_strIniPath);
			GetPrivateProfileString(SectionName,_T("Password"),_T(""),Buffer,_MAX_PATH,m_strIniPath);
			if(0!=Use||0!=Length||0!=_tcslen(Buffer)){
				CString msg;
				msg.Format(IDS_PASSWORD_CANT_SAVE,SectionName);
				if(IDYES==MessageBox(NULL,msg,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
					WritePrivateProfileString(SectionName,_T("UseFixedPassword"),_T("0"),m_strIniPath);
					WritePrivateProfileString(SectionName,_T("PasswordLength"),_T("0"),m_strIniPath);
					WritePrivateProfileString(SectionName,_T("Password"),_T(""),m_strIniPath);
				}
			}
		}
		break;
	case CONFIG_HKI:
	//=============
	// HKIkݒ
	//=============
		SectionName=_T("HKI");
		//kx
		HKI.CompressLevel=(HKI_COMPRESS_LEVEL)GetPrivateProfileInt(SectionName,_T("CompressLevel"),0,m_strIniPath);
		if(HKI.CompressLevel<0||HKI.CompressLevel>=HKI_COMPRESS_LEVEL_MAX_NUM){
			HKI.CompressLevel=(HKI_COMPRESS_LEVEL)0;
		}
		//ÍASY
		HKI.EncryptAlgorithm=(HKI_ENCRYPT_ALGORITHM)GetPrivateProfileInt(SectionName,_T("EncryptAlgorithm"),0,m_strIniPath);
		if(HKI.EncryptAlgorithm<0||HKI.EncryptAlgorithm>=HKI_ENCRYPT_ALGORITHM_MAX_NUM){
			HKI.EncryptAlgorithm=(HKI_ENCRYPT_ALGORITHM)0;
		}
		break;
	case CONFIG_BGA:
	//=============
	// BGAkݒ
	//=============
		SectionName=_T("BGA");
		//kx
		BGA.BZALevel=GetPrivateProfileInt(SectionName,_T("BZALevel"),9,m_strIniPath);
		if(BGA.BZALevel<BZA_COMPRESS_LEVEL_LOWEST||BGA.BZALevel>=BZA_COMPRESS_LEVEL_HIGHEST){
			BGA.BZALevel=9;
		}
		BGA.GZALevel=GetPrivateProfileInt(SectionName,_T("GZALevel"),9,m_strIniPath);
		if(BGA.GZALevel<GZA_COMPRESS_LEVEL_LOWEST||BGA.GZALevel>=GZA_COMPRESS_LEVEL_HIGHEST){
			BGA.GZALevel=9;
		}
		break;
	case CONFIG_AISH:
	//====================
	// AISHGR[hݒ
	//====================
		SectionName=_T("AISH");
		//ISHGR[h^Cv
		AISH.EncodeType=(ISH_ENCODE_TYPE)GetPrivateProfileInt(SectionName,_T("EncodeType"),0,m_strIniPath);
		if(AISH.EncodeType<(ISH_ENCODE_TYPE)0||AISH.EncodeType>=ISH_ENCODE_TYPE_MAX_NUM){
			AISH.EncodeType=(ISH_ENCODE_TYPE)0;
		}
		//uuencode`FbNT
		AISH.UUEncodeChecksum=GetPrivateProfileInt(SectionName,_T("UUEChecksum"),FALSE,m_strIniPath);
		break;
	case CONFIG_XACRETT:
	//=============
	// XacRettݒ
	//=============
		SectionName=_T("XacRett");
		//XacRettLɂ邩ǂ
		XACRETT.EnableDLL=GetPrivateProfileInt(SectionName,_T("EnableDLL"),FALSE,m_strIniPath);
		//XacRett֌W̃j[Lɂ邩ǂ
		XACRETT.EnableShellMenu=GetPrivateProfileInt(SectionName,_T("EnableShellMenu"),FALSE,m_strIniPath);
		//XacRettD悷gq
		{
			DWORD Length=1024;
			while(true){
				DWORD dwRead=GetPrivateProfileString(SectionName,_T("Extension"),_T(""),XACRETT.Extensions.GetBuffer(Length),Length-1,m_strIniPath);
				XACRETT.Extensions.ReleaseBuffer();
				if(dwRead==Length-2){
					TRACE(_T("Extending buffer...\n"));
					Length+=1024;	//obt@TCYg
				}
				else{
					break;
				}
			}
		}
		break;
	case CONFIG_B2E:
	//=============
	// B2Eݒ
	//=============
		SectionName=_T("B2E");
		//B2E32.dllLɂ邩ǂ
		B2E.EnableDLL=GetPrivateProfileInt(SectionName,_T("EnableDLL"),FALSE,m_strIniPath);
		//B2E֌W̃j[Lɂ邩ǂ
		B2E.EnableShellMenu=GetPrivateProfileInt(SectionName,_T("EnableShellMenu"),FALSE,m_strIniPath);
		//XNvg̃fBNg
		GetPrivateProfileString(SectionName,_T("ScriptDirectory"),_T(""),B2E.ScriptDirectory,_MAX_PATH,m_strIniPath);
		//B2EXacRettD
		B2E.Priority=GetPrivateProfileInt(SectionName,_T("Priority"),FALSE,m_strIniPath);
		//B2ED悷gq
		{
			DWORD Length=1024;
			while(true){
				DWORD dwRead=GetPrivateProfileString(SectionName,_T("Extension"),_T(""),B2E.Extensions.GetBuffer(Length),Length-1,m_strIniPath);
				B2E.Extensions.ReleaseBuffer();
				if(dwRead==Length-2){
					TRACE(_T("Extending buffer...\n"));
					Length+=1024;	//obt@TCYg
				}
				else{
					break;
				}
			}
		}
		break;
	case CONFIG_LOAD_ALL:
		{
		for(int i=0;i<(int)CONFIG_LOAD_ALL;i++){
			LoadConfig((CONFIG_TYPE)i);
		}
		}
		break;
	case CONFIG_FILELISTWINDOW:
	//================================
	// t@CXgEBhE̐ݒ
	//================================
		SectionName=_T("FileListWindow");
		//EBhE̐ݒۑ
		FileListWindow.StoreSetting=GetPrivateProfileInt(SectionName,_T("StoreSetting"),TRUE,m_strIniPath);
		//EBhE̕ƍ
		FileListWindow.Width=GetPrivateProfileInt(SectionName,_T("Width"),760,m_strIniPath);
		if(FileListWindow.Width<0){
			FileListWindow.Width=760;
		}
		FileListWindow.Height=GetPrivateProfileInt(SectionName,_T("Height"),500,m_strIniPath);
		if(FileListWindow.Height<0){
			FileListWindow.Height=500;
		}
		//c[r[̕
		FileListWindow.TreeWidth=GetPrivateProfileInt(SectionName,_T("TreeWidth"),175,m_strIniPath);
		if(FileListWindow.TreeWidth<0){
			FileListWindow.TreeWidth=175;
		}
		//Xgr[̃X^C(Default:LVS_ICON)
		FileListWindow.ListStyle=GetPrivateProfileInt(SectionName,_T("ListStyle"),0,m_strIniPath);
		if(
			(LVS_LIST!=FileListWindow.ListStyle)&&
			(LVS_REPORT!=FileListWindow.ListStyle)&&
			(LVS_SMALLICON!=FileListWindow.ListStyle)&&
			(LVS_ICON!=FileListWindow.ListStyle)
		)FileListWindow.ListStyle=LVS_ICON;

		//---------
		//\[g̐ݒ
		//J
		FileListWindow.SortColumn=GetPrivateProfileInt(SectionName,_T("SortColumn"),-1,m_strIniPath);
		if(FileListWindow.SortColumn<FILEINFO_INVALID||FileListWindow.SortColumn>=FILEINFO_MAX_NUM){
			FileListWindow.SortColumn=FILEINFO_INVALID;
		}
		///~
		FileListWindow.SortDescending=GetPrivateProfileInt(SectionName,_T("Descending"),TRUE,m_strIniPath);
		//----------
		//EBhËʒuۑ
		FileListWindow.StoreWindowPosition=GetPrivateProfileInt(SectionName,_T("StoreWindowPosition"),FALSE,m_strIniPath);
		//EBhE̍W
		FileListWindow.WindowPos_x=GetPrivateProfileInt(SectionName,_T("x"),0,m_strIniPath);
		FileListWindow.WindowPos_y=GetPrivateProfileInt(SectionName,_T("y"),0,m_strIniPath);
		//---------
		//ӖȃpX𖳎邩
		FileListWindow.IgnoreMeaninglessPath=GetPrivateProfileInt(SectionName,_T("IgnoreMeaninglessPath"),TRUE,m_strIniPath);
		//Kw\𖳎邩
		FileListWindow.FileListMode=(FILELISTMODE)GetPrivateProfileInt(SectionName,_T("FileListMode"),0,m_strIniPath);
		if(FileListWindow.FileListMode<0||FileListWindow.FileListMode>=FILELISTMODE_MAX_NUM){
			FileListWindow.FileListMode=(FILELISTMODE)0;
		}
		//---------
		//߂c[WJ
		FileListWindow.ExpandTree=GetPrivateProfileInt(SectionName,_T("ExpandTree"),FALSE,m_strIniPath);
		//oCgPʂŃt@CTCY\L
		FileListWindow.DisplayFileSizeInByte=GetPrivateProfileInt(SectionName,_T("DisplayFileSizeInByte"),FALSE,m_strIniPath);
		//[ESC]L[ŏI
		FileListWindow.ExitWithEscape=GetPrivateProfileInt(SectionName,_T("ExitWithEscape"),FALSE,m_strIniPath);

		//Xgr[J̕я
		{
			CString Temp;
			{for(int i=0;i<FILEINFO_MAX_NUM;i++){
				//т̏l쐬(0,1,2,3...)
				TCHAR szBuf[8]={0};
				wsprintf(szBuf,_T("%d"),i);
				Temp+=szBuf;
				if(i!=FILEINFO_MAX_NUM-1){
					Temp+=_T(",");
				}
				//z񏉊
				FileListWindow.ColumnOrderArray[i]=i;
			}}
			GetPrivateProfileString(SectionName,_T("ColumnOrder"),Temp,Buffer,_MAX_PATH,m_strIniPath);

			//J̕я擾
			int Index=0;
			LPCTSTR lpArrayString=Buffer;
			for(;_T('\0')!=*lpArrayString&&Index<FILEINFO_MAX_NUM;Index++){
				Temp.Empty();
				for(;;){
					if(_T(',')==*lpArrayString||_T('\0')==*lpArrayString){
						lpArrayString++;
						break;
					}
					else{
						Temp+=*lpArrayString;
						lpArrayString++;
					}
				}
				FileListWindow.ColumnOrderArray[Index]=_ttoi(Temp);
				if(FileListWindow.ColumnOrderArray[Index]<-1||FileListWindow.ColumnOrderArray[Index]>=FILEINFO_MAX_NUM){
					FileListWindow.ColumnOrderArray[Index]=Index;
				}
			}
		}
		//֘AtŊJ/ۂgq
		{
			//
			DWORD Length=1024;
			while(true){
				DWORD dwRead=GetPrivateProfileString(SectionName,_T("OpenAssocAccept"),CString(MAKEINTRESOURCE(IDS_FILELIST_OPENASSOC_DEFAULT_ACCEPT)),FileListWindow.OpenAssoc.Accept.GetBuffer(Length),Length-1,m_strIniPath);
				FileListWindow.OpenAssoc.Accept.ReleaseBuffer();
				if(dwRead==Length-2){
//					TRACE(_T("Extending buffer...\n"));
					Length+=1024;	//obt@TCYg
				}
				else{
					break;
				}
			}
			//
			Length=1024;
			while(true){
				DWORD dwRead=GetPrivateProfileString(SectionName,_T("OpenAssocDeny"),CString(MAKEINTRESOURCE(IDS_FILELIST_OPENASSOC_DEFAULT_DENY)),FileListWindow.OpenAssoc.Deny.GetBuffer(Length),Length-1,m_strIniPath);
				FileListWindow.OpenAssoc.Deny.ReleaseBuffer();
				if(dwRead==Length-2){
//					TRACE(_T("Extending buffer...\n"));
					Length+=1024;	//obt@TCYg
				}
				else{
					break;
				}
			}
		}
		//uvOŊJvj[̃R}h
		{
			//Â̔j
			FileListWindow.MenuCommandArray.clear();
			UINT iIndex=0;
			for(;iIndex<USERAPP_MAX_NUM;iIndex++){
				CString strSectionName;
				strSectionName.Format(_T("UserApp%d"),iIndex);
				if(!UtilCheckINISectionExists(strSectionName,m_strIniPath)){
					break;
				}
				CMenuCommandItem mci={0};
				//vÕpX
				GetPrivateProfileString(strSectionName,_T("Path"),_T(""),mci.Path,sizeof(mci.Path)/sizeof(mci.Path[0])-1,m_strIniPath);
				//p[^
				GetPrivateProfileString(strSectionName,_T("Param"),_T(""),mci.Param,sizeof(mci.Param)/sizeof(mci.Param[0])-1,m_strIniPath);
				//fBNg
				GetPrivateProfileString(strSectionName,_T("Dir"),_T(""),mci.Dir,sizeof(mci.Dir)/sizeof(mci.Dir[0])-1,m_strIniPath);
				//LvV
				GetPrivateProfileString(strSectionName,_T("Caption"),strSectionName,mci.Caption,sizeof(mci.Caption)/sizeof(mci.Caption[0])-1,m_strIniPath);
				FileListWindow.MenuCommandArray.push_back(mci);
			}
		}
		break;
	default:
		ASSERT(!"");
		return false;
	}
	return true;
}

bool CConfigManager::SaveConfig(CONFIG_TYPE type)
{
	LPCTSTR SectionName=NULL;
	switch(type){
	case CONFIG_COMMON:	//ʐݒ
	//========================
	// ̃o[WLq
	//========================
		SectionName=_T("LhaForge");
		WritePrivateProfileString(SectionName,_T("Version"),CString(MAKEINTRESOURCE(IDS_LHAFORGE_VERSION_STRING)),m_strIniPath);

	//==============
	// ko͐ݒ
	//==============
		SectionName=_T("Compress");
		UtilWritePrivateProfileInt(SectionName,_T("OutputDirType"),Common.Compress.OutputDirType,m_strIniPath);

		WritePrivateProfileString(SectionName,_T("OutputDir"),Common.Compress.OutputDir,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("OpenFolder"),Common.Compress.OpenDir,m_strIniPath);

		//o̓t@Cw肷邩ǂ
		UtilWritePrivateProfileInt(SectionName,_T("SpecifyName"),Common.Compress.SpecifyOutputFilename,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("LimitCompressFileCount"),Common.Compress.LimitCompressFileCount,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("MaxCompressFileCount"),Common.Compress.MaxCompressFileCount,m_strIniPath);

		//ftHgkp[^gpȂtrue
		UtilWritePrivateProfileInt(SectionName,_T("UseDefaultParameter"),Common.Compress.UseDefaultParameter,m_strIniPath);

		//ftHgkp[^(`w)
		UtilWritePrivateProfileInt(SectionName,_T("DefaultType"),Common.Compress.DefaultType,m_strIniPath);

		//ftHgkp[^̃IvV
		UtilWritePrivateProfileInt(SectionName,_T("DefaultOptions"),Common.Compress.DefaultOptions,m_strIniPath);

		//B2Ek̏
		WritePrivateProfileString(SectionName,_T("DefaultB2EFormat"),Common.Compress.DefaultB2EFormat,m_strIniPath);
		WritePrivateProfileString(SectionName,_T("DefaultB2EMethod"),Common.Compress.DefaultB2EMethod,m_strIniPath);
	//==============
	// 𓀏o͐ݒ
	//==============
		SectionName=_T("Extract");
		UtilWritePrivateProfileInt(SectionName,_T("OutputDirType"),Common.Extract.OutputDirType,m_strIniPath);

		WritePrivateProfileString(SectionName,_T("OutputDir"),Common.Extract.OutputDir,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("OpenFolder"),Common.Extract.OpenDir,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("CreateDir"),Common.Extract.CreateDir,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("ForceOverwrite"),Common.Extract.ForceOverwrite,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("RemoveSymbolAndNumber"),Common.Extract.RemoveSymbolAndNumber,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("CreateNoFolderIfSingleFileOnly"),Common.Extract.CreateNoFolderIfSingleFileOnly,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("LimitExtractFileCount"),Common.Extract.LimitExtractFileCount,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("MaxExtractFileCount"),Common.Extract.MaxExtractFileCount,m_strIniPath);

		//ɉ𓀂łkt@C폜
		UtilWritePrivateProfileInt(SectionName,_T("DeleteArchiveAfterExtract"),Common.Extract.DeleteArchiveAfterExtract,m_strIniPath);

		//𓀌t@CݔɈړ
		UtilWritePrivateProfileInt(SectionName,_T("MoveToRecycleBin"),Common.Extract.MoveToRecycleBin,m_strIniPath);

		//mFɃA[JCu폜/ݔɈړ
		UtilWritePrivateProfileInt(SectionName,_T("DeleteNoConfirm"),Common.Extract.DeleteNoConfirm,m_strIniPath);

		//𓀃G[młȂꍇ폜
		UtilWritePrivateProfileInt(SectionName,_T("ForceDelete"),Common.Extract.ForceDelete,m_strIniPath);

		//}`{[폜
		UtilWritePrivateProfileInt(SectionName,_T("DeleteMultiVolume"),Common.Extract.DeleteMultiVolume,m_strIniPath);
	//==============
	// o͈ʐݒ
	//==============
		SectionName=_T("Output");
		// o͐ނɑ΂x
		UtilWritePrivateProfileInt(SectionName,_T("WarnNetwork"),Common.WarnNetwork,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("WarnRemovable"),Common.WarnRemovable,m_strIniPath);

		// o͐悪Ȃꍇ̐ݒ
		UtilWritePrivateProfileInt(SectionName,_T("OnDirNotFound"),Common.OnDirNotFound,m_strIniPath);

	//==========================
	// O\^C~O
	//==========================
		SectionName=_T("LogView");
		UtilWritePrivateProfileInt(SectionName,_T("LogViewEvent"),Common.LogViewEvent,m_strIniPath);

	//==============
	// t@Cݒ
	//==============
		SectionName=_T("Filer");
		UtilWritePrivateProfileInt(SectionName,_T("UseFiler"),Common.Filer.UseFiler,m_strIniPath);

		WritePrivateProfileString(SectionName,_T("FilerPath"),Common.Filer.FilerPath,m_strIniPath);
		WritePrivateProfileString(SectionName,_T("Param"),Common.Filer.Param,m_strIniPath);
		break;
	case CONFIG_OPENACTION:
	//==================
	// ֘Atݒ
	//==================
		SectionName=_T("OpenAction");
		//I
		UtilWritePrivateProfileInt(SectionName,_T("OpenAction"),OpenAction.OpenAction,m_strIniPath);
		UtilWritePrivateProfileInt(SectionName,_T("OpenAction_Shift"),OpenAction.OpenAction_Shift,m_strIniPath);
		UtilWritePrivateProfileInt(SectionName,_T("OpenAction_Ctrl"),OpenAction.OpenAction_Ctrl,m_strIniPath);
		break;
	case CONFIG_SHELL_EXT:	//VFgj[
	//==================================
	// ENbNj[̕\E\
	//==================================
		SectionName=_T("ShellMenu");
		UtilWritePrivateProfileInt(SectionName,_T("Compress"),ShellExt.ShellMenuCompress,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("Extract"),ShellExt.ShellMenuExtract,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("List"),ShellExt.ShellMenuList,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("Test"),ShellExt.ShellMenuTest,m_strIniPath);
		// Tuj[ȉɕ荞
		UtilWritePrivateProfileInt(SectionName,_T("UnderSubMenu"),ShellExt.ShellMenuUnderSubMenu,m_strIniPath);
	//==================================
	// EhbOj[̕\E\
	//==================================
		SectionName=_T("DragMenu");
		UtilWritePrivateProfileInt(SectionName,_T("Compress"),ShellExt.DragMenuCompress,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("Extract"),ShellExt.DragMenuExtract,m_strIniPath);
		// Tuj[ȉɕ荞
		UtilWritePrivateProfileInt(SectionName,_T("UnderSubMenu"),ShellExt.DragMenuUnderSubMenu,m_strIniPath);
	//====================
	// gj[̕\
	//====================
		SectionName=_T("ExtraMenu");
		UtilWritePrivateProfileInt(SectionName,_T("ForceExtraMenu"),ShellExt.ForceExtraMenu,m_strIniPath);
	//============================
	// JX^}CYj[̎gp
	//============================
		SectionName=_T("CustomMenu");
		UtilWritePrivateProfileInt(SectionName,_T("UseCustom"),ShellExt.UseCustomMenu,m_strIniPath);
		break;
	case CONFIG_UPDATE:
	//================
	// XVmF𑣂
	//================
		SectionName=_T("Update");
		UtilWritePrivateProfileInt(SectionName,_T("AskUpdate"),Update.AskUpdate,m_strIniPath);

		UtilWritePrivateProfileInt(SectionName,_T("Interval"),Update.Interval,m_strIniPath);

		//XVCaldixŋL^
		//XVLZLFCaldix.ini̓i߂邪A
		//݂Ɏsꍇz肵ă[U[ʐݒt@Cɂݒ
		break;
	case CONFIG_LZH:
	//=============
	// LZHkݒ
	//=============
		SectionName=_T("LZH");
		//k`
		UtilWritePrivateProfileInt(SectionName,_T("CompressType"),LZH.CompressType,m_strIniPath);
		//SFX̐ݒsǂ
		UtilWritePrivateProfileInt(SectionName,_T("ConfigSFX"),LZH.ConfigSFX,m_strIniPath);
		break;
	case CONFIG_ZIP:
	//=============
	// ZIPkݒ
	//=============
		SectionName=_T("ZIP");
		//k`
		UtilWritePrivateProfileInt(SectionName,_T("CompressType"),ZIP.CompressType,m_strIniPath);
		//kx
		UtilWritePrivateProfileInt(SectionName,_T("CompressLevel"),ZIP.CompressLevel,m_strIniPath);
		//㋉ݒ
		//D悷郁̃oCgw肷邩ǂ
		UtilWritePrivateProfileInt(SectionName,_T("SpecifyDeflateMemorySize"),ZIP.SpecifyDeflateMemorySize,m_strIniPath);
		//D悷郁̃oCg
		UtilWritePrivateProfileInt(SectionName,_T("DeflateMemorySize"),ZIP.DeflateMemorySize,m_strIniPath);
		//GR[_̃pXw肷邩ǂ
		UtilWritePrivateProfileInt(SectionName,_T("SpecifyDeflatePassNumber"),ZIP.SpecifyDeflatePassNumber,m_strIniPath);
		//GR[_̃pX
		UtilWritePrivateProfileInt(SectionName,_T("DeflatePassNumber"),ZIP.DeflatePassNumber,m_strIniPath);
		break;
	case CONFIG_CAB:
	//=============
	// CABkݒ
	//=============
		SectionName=_T("CAB");
		//k`
		UtilWritePrivateProfileInt(SectionName,_T("CompressType"),CAB.CompressType,m_strIniPath);
		//LZXk̃x
		UtilWritePrivateProfileInt(SectionName,_T("LZXLevel"),CAB.LZX_Level,m_strIniPath);
		break;
	case CONFIG_7Z:
	//============
	// 7zkݒ
	//============
		SectionName=_T("7Z");
		//vZbggǂ
		UtilWritePrivateProfileInt(SectionName,_T("UsePreset"),SEVEN_ZIP.UsePreset,m_strIniPath);
		//k`
		UtilWritePrivateProfileInt(SectionName,_T("CompressType"),SEVEN_ZIP.CompressType,m_strIniPath);
		//kx
		UtilWritePrivateProfileInt(SectionName,_T("CompressLevel"),SEVEN_ZIP.CompressLevel,m_strIniPath);
		//LZMAk[h
		UtilWritePrivateProfileInt(SectionName,_T("LZMAMode"),SEVEN_ZIP.LZMA_Mode,m_strIniPath);
		//\bhk
		UtilWritePrivateProfileInt(SectionName,_T("SolidMode"),SEVEN_ZIP.SolidMode,m_strIniPath);
		//wb_k
		UtilWritePrivateProfileInt(SectionName,_T("HeaderCompression"),SEVEN_ZIP.HeaderCompression,m_strIniPath);
		//wb_Sk
		UtilWritePrivateProfileInt(SectionName,_T("HeaderFullCompression"),SEVEN_ZIP.FullHeaderCompression,m_strIniPath);
		//wb_Í
		UtilWritePrivateProfileInt(SectionName,_T("HeaderEncryption"),SEVEN_ZIP.HeaderEncryption,m_strIniPath);
		//㋉ݒ
		//PPMd̃fTCYw肷邩ǂ
		UtilWritePrivateProfileInt(SectionName,_T("SpecifyPPMdModelSize"),SEVEN_ZIP.SpecifyPPMdModelSize,m_strIniPath);
		//PPMd̃fTCY
		UtilWritePrivateProfileInt(SectionName,_T("PPMdModelSize"),SEVEN_ZIP.PPMdModelSize,m_strIniPath);
		break;
	case CONFIG_TAR:
	//====================
	// TAR/GZ/BZ2kݒ
	//====================
		SectionName=_T("TAR");
		//GZIP̈kx
		UtilWritePrivateProfileInt(SectionName,_T("GZIPLevel"),TAR.GzipCompressLevel,m_strIniPath);
		//BZIP2̈kx
		UtilWritePrivateProfileInt(SectionName,_T("BZIP2Level"),TAR.Bzip2CompressLevel,m_strIniPath);
		break;
	case CONFIG_JACK:
	//==============
	// JACKkݒ
	//==============
		SectionName=_T("JACK");
		UtilWritePrivateProfileInt(SectionName,_T("SpecifyAtCompress"),JACK.SpecifyVolumeSizeAtCompress,m_strIniPath);
		UtilWritePrivateProfileInt(SectionName,_T("VolumeSize"),JACK.VolumeSize,m_strIniPath);
		break;
	case CONFIG_BH:
		//Nothing to do.
		break;
	case CONFIG_YZ1:
		//Nothing to do.
		break;
	case CONFIG_HKI:
	//=============
	// HKIkݒ
	//=============
		SectionName=_T("HKI");
		//kx
		UtilWritePrivateProfileInt(SectionName,_T("CompressLevel"),HKI.CompressLevel,m_strIniPath);
		//ÍASY
		UtilWritePrivateProfileInt(SectionName,_T("EncryptAlgorithm"),HKI.EncryptAlgorithm,m_strIniPath);
		break;
	case CONFIG_BGA:
	//=============
	// BGAkݒ
	//=============
		SectionName=_T("BGA");
		//kx
		UtilWritePrivateProfileInt(SectionName,_T("BZALevel"),BGA.BZALevel,m_strIniPath);
		UtilWritePrivateProfileInt(SectionName,_T("GZALevel"),BGA.GZALevel,m_strIniPath);
		break;
	case CONFIG_AISH:
	//====================
	// AISHGR[hݒ
	//====================
		SectionName=_T("AISH");
		//ISHGR[h^Cv
		UtilWritePrivateProfileInt(SectionName,_T("EncodeType"),AISH.EncodeType,m_strIniPath);
		//uuencode`FbNT
		UtilWritePrivateProfileInt(SectionName,_T("UUEChecksum"),AISH.UUEncodeChecksum,m_strIniPath);
		break;
	case CONFIG_XACRETT:
	//=============
	// XacRettݒ
	//=============
		SectionName=_T("XacRett");
		//XacRettLɂ邩ǂ
		UtilWritePrivateProfileInt(SectionName,_T("EnableDLL"),XACRETT.EnableDLL,m_strIniPath);
		//XacRett֌W̃j[Lɂ邩ǂ
		UtilWritePrivateProfileInt(SectionName,_T("EnableShellMenu"),XACRETT.EnableShellMenu,m_strIniPath);
		//XacRettD悷gq
		WritePrivateProfileString(SectionName,_T("Extension"),XACRETT.Extensions,m_strIniPath);
		break;
	case CONFIG_B2E:
	//=============
	// B2Eݒ
	//=============
		SectionName=_T("B2E");
		//B2E32.dllLɂ邩ǂ
		UtilWritePrivateProfileInt(SectionName,_T("EnableDLL"),B2E.EnableDLL,m_strIniPath);
		//B2E֌W̃j[Lɂ邩ǂ
		UtilWritePrivateProfileInt(SectionName,_T("EnableShellMenu"),B2E.EnableShellMenu,m_strIniPath);
		//XNvg̃fBNg
		WritePrivateProfileString(SectionName,_T("ScriptDirectory"),B2E.ScriptDirectory,m_strIniPath);
		//B2EXacRettD
		UtilWritePrivateProfileInt(SectionName,_T("Priority"),B2E.Priority,m_strIniPath);
		//B2ED悷gq
		WritePrivateProfileString(SectionName,_T("Extension"),B2E.Extensions,m_strIniPath);
		break;
	case CONFIG_LOAD_ALL:
		{
		for(int i=0;i<(int)CONFIG_LOAD_ALL;i++){
			SaveConfig((CONFIG_TYPE)i);
		}
		}
		break;
	case CONFIG_FILELISTWINDOW:
	//================================
	// t@CXgEBhE̐ݒ
	//================================
		SectionName=_T("FileListWindow");
		//EBhE̐ݒۑ
		UtilWritePrivateProfileInt(SectionName,_T("StoreSetting"),FileListWindow.StoreSetting,m_strIniPath);
		if(FileListWindow.StoreSetting){
			//EBhE̕ƍ
			UtilWritePrivateProfileInt(SectionName,_T("Width"),FileListWindow.Width,m_strIniPath);
			UtilWritePrivateProfileInt(SectionName,_T("Height"),FileListWindow.Height,m_strIniPath);
			//c[r[̕
			UtilWritePrivateProfileInt(SectionName,_T("TreeWidth"),FileListWindow.TreeWidth,m_strIniPath);
			//Xgr[̃X^C
			UtilWritePrivateProfileInt(SectionName,_T("ListStyle"),FileListWindow.ListStyle,m_strIniPath);
			//---------
			//\[g̐ݒ
			//J
			UtilWritePrivateProfileInt(SectionName,_T("SortColumn"),FileListWindow.SortColumn,m_strIniPath);
			///~
			UtilWritePrivateProfileInt(SectionName,_T("Descending"),FileListWindow.SortDescending,m_strIniPath);
		}
		//----------
		//EBhËʒuۑ
		UtilWritePrivateProfileInt(SectionName,_T("StoreWindowPosition"),FileListWindow.StoreWindowPosition,m_strIniPath);
		if(FileListWindow.StoreWindowPosition){
			//EBhE̍W
			UtilWritePrivateProfileInt(SectionName,_T("x"),FileListWindow.WindowPos_x,m_strIniPath);

			UtilWritePrivateProfileInt(SectionName,_T("y"),FileListWindow.WindowPos_y,m_strIniPath);
		}
		//---------
		//ӖȃpX𖳎邩
		UtilWritePrivateProfileInt(SectionName,_T("IgnoreMeaninglessPath"),FileListWindow.IgnoreMeaninglessPath,m_strIniPath);
		//Kw\𖳎邩
		UtilWritePrivateProfileInt(SectionName,_T("FileListMode"),FileListWindow.FileListMode,m_strIniPath);
		//---------
		//߂c[WJ
		UtilWritePrivateProfileInt(SectionName,_T("ExpandTree"),FileListWindow.ExpandTree,m_strIniPath);
		//oCgPʂŃt@CTCY\L
		UtilWritePrivateProfileInt(SectionName,_T("DisplayFileSizeInByte"),FileListWindow.DisplayFileSizeInByte,m_strIniPath);
		//[ESC]L[ŏI
		UtilWritePrivateProfileInt(SectionName,_T("ExitWithEscape"),FileListWindow.ExitWithEscape,m_strIniPath);

		//Xgr[J̕я
		{
			CString Buffer;
			for(int i=0;i<FILEINFO_MAX_NUM;i++){
				TCHAR szBuf[8]={0};
				wsprintf(szBuf,_T("%d"),FileListWindow.ColumnOrderArray[i]);
				Buffer+=szBuf;
				if(i!=FILEINFO_MAX_NUM-1){
					Buffer+=_T(",");
				}
			}
			WritePrivateProfileString(SectionName,_T("ColumnOrder"),Buffer,m_strIniPath);
		}
		//֘AtŊJ/ۂgq
		//
		WritePrivateProfileString(SectionName,_T("OpenAssocAccept"),FileListWindow.OpenAssoc.Accept,m_strIniPath);
		//
		WritePrivateProfileString(SectionName,_T("OpenAssocDeny"),FileListWindow.OpenAssoc.Deny,m_strIniPath);

		//uvOŊJvj[̃R}h
		{
			UINT iIndex=0;
			UINT OldDataCount=0;
			//---Âf[^̐mF
			for(;iIndex<USERAPP_MAX_NUM;iIndex++){
				CString strSectionName;
				strSectionName.Format(_T("UserApp%d"),iIndex);
				if(!UtilCheckINISectionExists(strSectionName,m_strIniPath)){
					OldDataCount=iIndex;
					break;
				}
			}
			//---f[^̏㏑
			for(iIndex=0;iIndex<FileListWindow.MenuCommandArray.size();iIndex++){
				CString strSectionName;
				strSectionName.Format(_T("UserApp%d"),iIndex);
				const CMenuCommandItem &mci=FileListWindow.MenuCommandArray[iIndex];
				//vÕpX
				WritePrivateProfileString(strSectionName,_T("Path"),mci.Path,m_strIniPath);
				//p[^
				WritePrivateProfileString(strSectionName,_T("Param"),mci.Param,m_strIniPath);
				//fBNg
				WritePrivateProfileString(strSectionName,_T("Dir"),mci.Dir,m_strIniPath);
				//LvV
				WritePrivateProfileString(strSectionName,_T("Caption"),mci.Caption,m_strIniPath);
			}
			//---ÂZNV̔j
			for(;iIndex<OldDataCount;iIndex++){
				CString strSectionName;
				strSectionName.Format(_T("UserApp%d"),iIndex);
				WritePrivateProfileString(strSectionName,NULL,NULL,m_strIniPath);
			}
		}
		break;
	default:
		ASSERT(!"");
		return false;
	}
	return true;
}

void CConfigManager::WriteUpdateTime(time_t LastTime)
{
	LPCTSTR SectionName=_T("Update");

	//XVLZȂǁALFCaldix.iniLhaForgeXVKvƂ
	//---LFCaldix.iniɋL^
	UtilWritePrivateProfileInt(SectionName,_T("LastTime"),LastTime,m_strCaldixIniPath);
	//---[U[pt@CɋL^
	UtilWritePrivateProfileInt(SectionName,_T("LastTime"),LastTime,m_strIniPath);
}
