#pragma once

#include "config.h"
#include "../resource.h"
#include <atlddx.h>		// DDX/DDVgp邽

//====================================
// 7Z̐ݒ荀
//====================================
class CConfig7Z : public CDialogImpl<CConfig7Z>,public CWinDataExchange<CConfig7Z>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	CButton			Check_UsePreset;
	CButton			Radio_CompressType[SEVEN_ZIP_COMPRESS_TYPE_MAX_NUM];
	CButton			Radio_CompressLevel[SEVEN_ZIP_COMPRESS_LEVEL_MAX_NUM];
	CButton			Radio_LZMA_Mode[SEVEN_ZIP_LZMA_MODE_MAX_NUM];

	CButton			Check_SpecifyPPMdModelSize;
	CButton			Check_HeaderCompression;
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_7Z };

	// DDX}bv
	BEGIN_DDX_MAP(CConfig7Z)
		DDX_INT_RANGE(IDC_EDIT_7Z_PPMD_MODEL_SIZE, Config.SEVEN_ZIP.PPMdModelSize, SEVEN_ZIP_PPMD_MODEL_SIZE_LOWEST, SEVEN_ZIP_PPMD_MODEL_SIZE_HIGHEST)
		DDX_CHECK(IDC_CHECK_7Z_SOLID_MODE, Config.SEVEN_ZIP.SolidMode)
		DDX_CHECK(IDC_CHECK_7Z_HEADER_COMPRESSION, Config.SEVEN_ZIP.HeaderCompression)
		DDX_CHECK(IDC_CHECK_7Z_FULL_HEADER_COMPRESSION, Config.SEVEN_ZIP.FullHeaderCompression)
		DDX_CHECK(IDC_CHECK_7Z_HEADER_ENCRYPT, Config.SEVEN_ZIP.HeaderEncryption)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfig7Z)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_CHECK_7Z_HEADER_COMPRESSION,OnHeaderCompression)
		COMMAND_ID_HANDLER(IDC_CHECK_7Z_USE_PRESET,OnUsePreset)
		COMMAND_ID_HANDLER(IDC_CHECK_7Z_SPECIFY_PPMD_MODEL_SIZE,OnSpecifyPPMdModelSize)
		COMMAND_RANGE_HANDLER(IDC_RADIO_7Z_METHOD_LZMA,IDC_RADIO_7Z_METHOD_COPY, OnSelectCompressType)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	LRESULT OnHeaderCompression(WORD,WORD,HWND,BOOL&);
	LRESULT OnUsePreset(WORD,WORD,HWND,BOOL&);
	LRESULT OnSpecifyPPMdModelSize(WORD,WORD,HWND,BOOL&);
	LRESULT OnSelectCompressType(WORD,WORD,HWND,BOOL&);

	void OnDataValidateError(UINT nCtrlID, BOOL bSave, _XData& data){
		CString msg; 
		msg.Format(IDS_ERROR_VALUE_RANGE,data.intData.nMin, data.intData.nMax);
		ErrorMessage(msg);

		::SetFocus(GetDlgItem(nCtrlID));
		::SendMessage(GetDlgItem(nCtrlID),EM_SETSEL,0,-1);
	}

	CConfig7Z(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE(_T("CConfig7Z()\n"));
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

