#pragma once

#include "config.h"
#include "../resource.h"
#include <atlddx.h>		// DDX/DDVgp邽

//==================================
// t@CꗗEBhE̐ݒ荀
//==================================
class CConfigFileListWindow : public CDialogImpl<CConfigFileListWindow>,public CWinDataExchange<CConfigFileListWindow>,public CMessageFilter
{
protected:
	CConfigManager	&Config;

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

	void OnClearTemporary(UINT,int,HWND);	//cĂ܂e|fBNg폜
	void OnResetExt(UINT,int,HWND);			//֎~Egq̃Zbg

	CButton Radio_FileListMode[FILELISTMODE_MAX_NUM];

	CEdit Edit_Path,Edit_Param,Edit_Dir,Edit_Caption;
	CListViewCtrl List_Command;
	void OnBrowsePath(UINT, int, HWND);
	void OnBrowseDir(UINT, int, HWND);

	std::vector<CMenuCommandItem> m_MenuCommandArray;
	CMenuCommandItem *m_lpMenuCommandItem;	//ҏW̃R}hACe

	LRESULT OnGetDispInfo(LPNMHDR pnmh);
	LRESULT OnSelect(LPNMHDR pnmh);
	LRESULT OnUserAppMoveUp(WORD,WORD,HWND,BOOL&);
	LRESULT OnUserAppMoveDown(WORD,WORD,HWND,BOOL&);
	LRESULT OnUserAppNew(WORD,WORD,HWND,BOOL&);
	LRESULT OnUserAppDelete(WORD,WORD,HWND,BOOL&);
public:
	enum { IDD = IDD_PROPPAGE_CONFIG_FILELISTWINDOW };

	// DDX}bv
	BEGIN_DDX_MAP(CConfigFileListWindow)
		DDX_CHECK(IDC_CHECK_STORE_FILELISTWINDOW_SETTING, Config.FileListWindow.StoreSetting)
		DDX_CHECK(IDC_CHECK_STORE_FILELISTWINDOW_POSITION, Config.FileListWindow.StoreWindowPosition)
		DDX_CHECK(IDC_CHECK_IGNORE_MEANINGLESS_PATH, Config.FileListWindow.IgnoreMeaninglessPath)
		DDX_CHECK(IDC_CHECK_EXPAND_TREE, Config.FileListWindow.ExpandTree)
		DDX_CHECK(IDC_CHECK_DISPLAY_FILESIZE_IN_BYTE,Config.FileListWindow.DisplayFileSizeInByte)
		DDX_CHECK(IDC_CHECK_EXIT_WITH_ESCAPE,Config.FileListWindow.ExitWithEscape);
		DDX_TEXT(IDC_EDIT_OPENASSOC_ACCEPT, Config.FileListWindow.OpenAssoc.Accept)
		DDX_TEXT(IDC_EDIT_OPENASSOC_DENY, Config.FileListWindow.OpenAssoc.Deny)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigFileListWindow)
		NOTIFY_CODE_HANDLER_EX(LVN_GETDISPINFO, OnGetDispInfo)	//zXgr[
		NOTIFY_CODE_HANDLER_EX(LVN_ITEMCHANGED, OnSelect)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_CLEAR_TEMPORARY,OnClearTemporary)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_RESET_OPENASSOC_ACCEPT,OnResetExt)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_RESET_OPENASSOC_DENY,OnResetExt)

		COMMAND_ID_HANDLER(IDC_BUTTON_FILELIST_USERAPP_NEW,OnUserAppNew)
		COMMAND_ID_HANDLER(IDC_BUTTON_FILELIST_USERAPP_DELETE,OnUserAppDelete)
		COMMAND_ID_HANDLER(IDC_BUTTON_FILELIST_USERAPP_MOVEUP,OnUserAppMoveUp)
		COMMAND_ID_HANDLER(IDC_BUTTON_FILELIST_USERAPP_MOVEDOWN,OnUserAppMoveDown)

		COMMAND_ID_HANDLER_EX(IDC_BUTTON_FILELIST_USERAPP_BROWSE, OnBrowsePath)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_FILELIST_USERAPP_BROWSEDIR, OnBrowseDir)
		MSG_WM_INITDIALOG(OnInitDialog)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();

	CConfigFileListWindow(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE(_T("CConfigFileListWindow()\n"));
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

