#pragma once
#include "common.h"
#include "ArchiverCode/arc_interface.h"
#include "ArchiverCode/ArchiverUNLHA.h"
#include "ArchiverCode/ArchiverCAB.h"
#include "ArchiverCode/Archiver7ZIP.h"
#include "ArchiverCode/ArchiverTAR.h"
#include "ArchiverCode/ArchiverUNARJ.h"
#include "ArchiverCode/ArchiverUNGCA.h"
#include "ArchiverCode/ArchiverUNRAR.h"
#include "ArchiverCode/ArchiverUNACE.h"
#include "ArchiverCode/ArchiverUNIMP.h"
#include "ArchiverCode/ArchiverJACK.h"
//#include "ArchiverCode/ArchiverBH.h"
#include "ArchiverCode/ArchiverYZ1.h"
#include "ArchiverCode/ArchiverUNBEL.h"
//#include "ArchiverCode/ArchiverUNPMA.h"
#include "ArchiverCode/ArchiverUNHKI.h"
#include "ArchiverCode/ArchiverBGA.h"
#include "ArchiverCode/ArchiverAISH.h"
#include "ArchiverCode/ArchiverXACRETT.h"
#include "ArchiverCode/ArchiverB2E.h"

//DLL
enum DLL_ID{
	DLL_ID_UNKNOWN=-1,
	DLL_ID_UNLHA,
	DLL_ID_7ZIP,
	DLL_ID_CAB,
	DLL_ID_TAR,
	DLL_ID_JACK,
//	DLL_ID_BH,
	DLL_ID_YZ1,
//	DLL_ID_YZ2,
	DLL_ID_UNARJ,
	DLL_ID_UNGCA,
	DLL_ID_UNRAR,
	DLL_ID_UNACE,
	DLL_ID_UNIMP,
	DLL_ID_UNBEL,
//	DLL_ID_UNPMA,
	DLL_ID_UNHKI,
	DLL_ID_BGA,
	DLL_ID_AISH,
	DLL_ID_XACRETT,
	DLL_ID_B2E,
	DLL_ID_MAX_NUM
};


class CConfigManager;
DLL_ID GuessDllIDFromFileName(LPCTSTR,CConfigManager&);
DLL_ID GetDllIDFromParameterType(PARAMETER_TYPE);

class CArchiverDLLManager{
protected:
	CArchiverTAR	ArcTAR;
	CArchiverJACK	ArcJACK;
	CArchiverUNLHA	ArcUNLHA;
	CArchiver7ZIP	Arc7ZIP;
	CArchiverCAB	ArcCAB;
	CArchiverUNARJ	ArcUNARJ;
	CArchiverUNGCA	ArcUNGCA;
	CArchiverUNRAR	ArcUNRAR;
	CArchiverUNACE	ArcUNACE;
	CArchiverUNIMP	ArcUNIMP;
//	CArchiverBH		ArcBH;
	CArchiverYZ1	ArcYZ1;
	CArchiverUNBEL	ArcUNBEL;
//	CArchiverUNPMA	ArcPMA;
	CArchiverUNHKI	ArcUNHKI;
	CArchiverBGA	ArcBGA;
	CArchiverAISH	ArcAISH;
	CArchiverXACRETT ArcXACRETT;
	CArchiverB2E	ArcB2E;
	std::list<std::pair<CArchiverDLL*,DLL_ID> > ArchiverList;	//listvectorɂĂ;push̏ԂA[JCu`̏ԂɂȂ

	CArchiverDLLManager();
	CConfigManager *m_lpConfig;
public:
	virtual ~CArchiverDLLManager();

	static CArchiverDLLManager& GetInstance(){
		static CArchiverDLLManager Singleton;
		return Singleton;
	}

	CArchiverDLL* GetArchiver(LPCTSTR,DLL_ID ForceDLL=DLL_ID_UNKNOWN);	//ForceDLLDLL_IDw肷ƂDLLԂ
	CArchiverDLL* GetArchiver(DLL_ID,bool=false,bool=false);
	CArchiverB2E &GetB2EHandler();	//B2E32.dllʈ...
	void Final();
	void Free();

	void SetConfigManager(CConfigManager &Config){m_lpConfig=&Config;}
};

//---------------------
// QƗp̃e[u
//---------------------

//gqDLL_ID̑Ή\
const struct ARRAYITEM_EXT_DLLID{
	LPCTSTR	lpszExt;
	DLL_ID	DllID;
}Array_ExtDLLID[]={
	{_T(".lzh"),	DLL_ID_UNLHA},
	{_T(".lha"),	DLL_ID_UNLHA},
	{_T(".lzs"),	DLL_ID_UNLHA},
	{_T(".cab"),	DLL_ID_CAB},
	{_T(".zip"),	DLL_ID_7ZIP},
	{_T(".7z"),		DLL_ID_7ZIP},
	{_T(".jar"),	DLL_ID_7ZIP},
	{_T(".tar"),	DLL_ID_TAR},
	{_T(".tgz"),	DLL_ID_TAR},
	{_T(".gz"),		DLL_ID_TAR},
	{_T(".tbz"),	DLL_ID_TAR},
	{_T(".bz2"),	DLL_ID_TAR},
	{_T(".jak"),	DLL_ID_JACK},
//	{_T(".bh"),		DLL_ID_BH},		p~
	{_T(".hki"),	DLL_ID_UNHKI},
	{_T(".yz1"),	DLL_ID_YZ1},
//	{_T(".yz2"),	DLL_ID_YZ2},	p~
	{_T(".bza"),	DLL_ID_BGA},
	{_T(".gza"),	DLL_ID_BGA},

	{_T(".ish"),	DLL_ID_AISH},
	{_T(".uue"),	DLL_ID_AISH},
	//ISH֌WŉȂ
	{_T(".doc"),	DLL_ID_AISH},
	{_T(".txt"),	DLL_ID_AISH},
	{_T(".log"),	DLL_ID_AISH},

//ȉATARɂ𓀂̂݉\Ȍ`
	{_T(".z"),		DLL_ID_TAR},
	{_T(".taz"),	DLL_ID_TAR},
	{_T(".cpio"),	DLL_ID_TAR},
	{_T(".a"),		DLL_ID_TAR},
	{_T(".lib"),	DLL_ID_TAR},
	{_T(".rpm"),	DLL_ID_TAR},
	{_T(".deb"),	DLL_ID_TAR},
//͉𓀂̂ݑΉ̌`
	{_T(".arj"),	DLL_ID_UNARJ},
	{_T(".gca"),	DLL_ID_UNGCA},
	{_T(".rar"),	DLL_ID_UNRAR},
	{_T(".ace"),	DLL_ID_UNACE},
	{_T(".imp"),	DLL_ID_UNIMP},
	{_T(".bel"),	DLL_ID_UNBEL},
//	{_T(".pma"),	DLL_ID_UNPMA},	p~
};
const int ARRAY_EXT_DLLID_COUNT=sizeof(Array_ExtDLLID)/sizeof(ARRAYITEM_EXT_DLLID);


//PARAMETER_TYPEDLL_ID̑Ή\
const struct ARRAYITEM_PARAMETERTYPE_DLLID{
	PARAMETER_TYPE	ParameterType;
	DLL_ID			DllID;
}Array_ParameterTypeDLLID[]={
	{PARAMETER_LZH,		DLL_ID_UNLHA},

	{PARAMETER_ZIP,		DLL_ID_7ZIP},
	{PARAMETER_7Z,		DLL_ID_7ZIP},

	{PARAMETER_CAB,		DLL_ID_CAB},

	{PARAMETER_JACK,	DLL_ID_JACK},

//	{PARAMETER_BH,		DLL_ID_BH},		p~

	{PARAMETER_YZ1,		DLL_ID_YZ1},

//	{PARAMETER_YZ2,		DLL_ID_},		p~

	{PARAMETER_HKI,		DLL_ID_UNHKI},

	{PARAMETER_BZA,		DLL_ID_BGA},
	{PARAMETER_GZA,		DLL_ID_BGA},

	{PARAMETER_ISH,		DLL_ID_AISH},
	{PARAMETER_UUE,		DLL_ID_AISH},

	{PARAMETER_TAR,		DLL_ID_TAR},
	{PARAMETER_BZ2,		DLL_ID_TAR},
	{PARAMETER_GZ,		DLL_ID_TAR},
	{PARAMETER_TAR_GZ,	DLL_ID_TAR},
	{PARAMETER_TAR_BZ2,	DLL_ID_TAR},
};
const int ARRAY_PARAMETERTYPE_DLLID_COUNT=sizeof(Array_ParameterTypeDLLID)/sizeof(ARRAYITEM_PARAMETERTYPE_DLLID);


