#include "common.h"
#include "compress.h"
//#include "util.h"
#include "Components/LogDialog.h"

#include "resource.h"

#include "archivermanager.h"
#include "Components/Semaphore.h"

bool Compress(std::list<CString> &ParamList,const PARAMETER_TYPE Type,CConfigManager &Config,const int Options,LPCTSTR lpszSpecificOutputFileName,LPCTSTR lpszSpecificOutputDir)
{
	ASSERT(PARAMETER_B2E!=Type);	//B2Eł̈k͕ʊ֐
	TRACE(_T("Function ::Compress() started.\n"));

	CArchiverDLLManager &ArchiverManager=CArchiverDLLManager::GetInstance();
	Config.LoadConfig(CONFIG_COMMON);

	CArchiverDLL *Archiver=ArchiverManager.GetArchiver(GetDllIDFromParameterType(Type));
	if(!Archiver){
		//TRACE(_T("kpDLL擾łȂ\n"));
		return false;
	}

	//UNICODEΉ̃`FbN
	if(!Archiver->IsUnicodeCapable()){
		//UNICODEɑΉĂȂ
		for(std::list<CString>::iterator ite=ParamList.begin();ite!=ParamList.end();++ite){
			if(!UtilCheckT2A(*ite)){
				//t@CUNICODEt@Ck悤Ƃ
				ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_UNICODEPATH)));
				return false;
			}
		}
	}

	//----------------------------------------------
	// GZ/BZ2/JACKňk\(Pt@C)ǂ`FbN
	//----------------------------------------------
	if(PARAMETER_GZ==Type||PARAMETER_BZ2==Type||PARAMETER_JACK==Type){
		std::list<CString>::iterator ite;
		int FileCount=0;
		CString FileName;
		for(ite=ParamList.begin();ite!=ParamList.end();++ite){
			FileCount+=CountFileToCompress(*ite,FileName);
			if(FileCount>=2){
				ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_SINGLE_FILE_ONLY)));
				return false;
			}
		}
		if(0==FileCount){
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
			return false;
		}
		ParamList.clear();
		ParamList.push_back(FileName);
	}
	else if(PARAMETER_ISH==Type||PARAMETER_UUE==Type){
	//----------------------------------------------
	// ISH/UUEŕϊ\(t@Cǂ)`FbN
	//----------------------------------------------
		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();++ite){
			if(PathIsDirectory(*ite)){
				ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_CANT_COMPRESS_FOLDER)));
				return false;
			}
		}
	}

	//=========================================================
	// JgfBNgݒ̂߂\ŏI_pX擾
	//=========================================================
	CString BasePath;
	UtilGetBaseDirectory(BasePath,ParamList);
	TRACE(BasePath),TRACE(_T("\n"));

	//JgfBNgݒ
	SetCurrentDirectory(BasePath);

	//kt@C
	TRACE(_T("kt@C\n"));
	CString ArcFileName;
	if(!GetArchiveName(ArcFileName,ParamList,Type,Options,Config,lpszSpecificOutputFileName,lpszSpecificOutputDir,Archiver->IsUnicodeCapable()))
	{
		//ErrorMessage
		return false;
	}

	//====================================================================
	// ΉDLLŃt@CUNICODEt@Ck悤Ƃ
	//====================================================================
	if(!Archiver->IsUnicodeCapable()&&!UtilCheckT2A(ArcFileName)){
		//GetArchiveNameŒe؂Ȃ(B2E/JACKȂ)Œe
		//B2E͕ʌnŏĂ邪AÔ߁B
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_UNICODEPATH)));
		return false;
	}

	if(PARAMETER_JACK!=Type){
		if(PathFileExists(ArcFileName)){
			if(!DeleteFile(ArcFileName)){
				//폜łȂ
				LPVOID lpMsgBuf;
				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,NULL,GetLastError(),MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),(LPTSTR)&lpMsgBuf, 0, NULL);

				CString msg;
				msg.Format(IDS_ERROR_FILE_REPLACE,lpMsgBuf);
				LocalFree(lpMsgBuf);

				ErrorMessage(msg);
				return false;
			}
		}
//		if(Options&COMPRESS_SPLIT&&_T(".001")==ArcFileName.Right(4)){	//k
//			ArcFileName.Delete(ArcFileName.GetLength()-4,4);
//		}

		//======================================
		// X|Xt@CɋL邽߂
		// kΏۃt@CC
		//======================================
		const int BasePathLength=BasePath.GetLength();
		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();++ite){
			//x[XpXɑ΃pX擾 : ʂłpX̕Jbg
			//(*ite)=(*ite).Right((*ite).GetLength()-BasePathLength);
			(*ite).Delete(0,BasePathLength);

			//BasePathƓɂȂċɂȂĂ܂pX΁AJgfBNgwɓĂ
			if((*ite).IsEmpty()){
				*ite=_T(".");
			}
		}
	}

	//Z}tHɂr
	CSemaphoreLocker SemaphoreLock;
	if(Config.Common.Compress.LimitCompressFileCount){
		SemaphoreLock.Lock(LHAFORGE_COMPRESS_SEMAPHORE_NAME,Config.Common.Compress.MaxCompressFileCount);
	}


	TRACE(_T("ArchiverHandler Ăяo\n"));
	//------------
	// ks
	//------------
	CString strLog;
	bool bRet=Archiver->Compress(ArcFileName,ParamList,Config,Type,Options,strLog);
	//---O\
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(!bRet){
			CLogDialog LogDlg;
			LogDlg.SetData(strLog);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(strLog);
		LogDlg.DoModal();
		break;
	}


	//o͐tH_J
	if(bRet&&Config.Common.Compress.OpenDir){
		TCHAR Buffer[_MAX_PATH+1];
		FILL_ZERO(Buffer);
		_tcsncpy_s(Buffer,ArcFileName,_MAX_PATH);
		PathRemoveFileSpec(Buffer);
		if(!Config.Common.Filer.UseFiler){
			TCHAR ExplorerPath[_MAX_PATH+1];
			FILL_ZERO(ExplorerPath);
			GetWindowsDirectory(ExplorerPath,_MAX_PATH);
			PathAppend(ExplorerPath,_T("Explorer.exe"));
			ShellExecute(NULL, _T("open"), ExplorerPath, Buffer, NULL, SW_SHOWNORMAL);
		}else{
			PathQuoteSpaces(Buffer);
			CString Param=Config.Common.Filer.Param;
			Param.Replace(_T("{dir}"),Buffer);
			ShellExecute(NULL, _T("open"), Config.Common.Filer.FilerPath,Param, NULL, SW_SHOWNORMAL);
		}
	}

	TRACE(_T("Exit Compress()\n"));
	return bRet;
}


/*************************************************************
A[JCut@C肷B

 {Iɂ́AR}hCŗ^t@ĈA
ŏ̃t@CɂāAgqςt@CB
*************************************************************/
bool GetArchiveName(CString &ArcFileName,std::list<CString> &OrgFileNameList,const PARAMETER_TYPE Type,const int Options,CConfigManager &Config,LPCTSTR lpszSpecificOutputFileName,LPCTSTR lpszSpecificOutputDir,bool bUnicodeCapable)
{
	//==================
	// t@C̐
	//==================
	bool bDirectory=false;	//kΏۂɎw肳ꂽtH_Ȃtrue;tH_ƃt@CŖ'.'̈ς
	bool bDriveRoot=false;	//kΏۂhCũ[g(X:\ etc.)Ȃtrue
	TCHAR szOrgFileName[_MAX_PATH+1]={0};

	bool bFileNameSpecified=(NULL!=lpszSpecificOutputFileName&&0<_tcslen(lpszSpecificOutputFileName));

	if(bFileNameSpecified){
		_tcsncpy_s(szOrgFileName,lpszSpecificOutputFileName,_MAX_PATH);
		PathStripPath(szOrgFileName);	//pX菜
	}
	else{
		//擪̃t@CɎbIɃt@Co
		//OrgFileNameList!empty񑩂Ă
		_tcsncpy_s(szOrgFileName,*OrgFileNameList.begin(),_MAX_PATH);

		//fBNgǂ
		bDirectory=BOOL2bool(PathIsDirectory(szOrgFileName));
		//hCũ[gǂ
		TCHAR Temp[_MAX_PATH+1]={0};
		_tcsncpy_s(Temp,szOrgFileName,_MAX_PATH);
		PathAddBackslash(Temp);
		bDriveRoot=BOOL2bool(PathIsRoot(Temp));
	}
	TRACE(_T("GetArchiveName:OrgFileName:%s\n"),szOrgFileName);

	//k`̏
	int Index=0;
	for(;Index<COMPRESS_PARAM_COUNT;Index++){
		if(Type==CompressParameterArray[Index].Type){
			if(Options==CompressParameterArray[Index].Options){
				break;
			}
		}
	}
	if(Index>=COMPRESS_PARAM_COUNT){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_ILLEGAL_FORMAT_TYPE)));
		return false;
	}

	//gq
	CString Ext;
	if(bFileNameSpecified){
		TCHAR Buffer[_MAX_EXT+1];
		FILL_ZERO(Buffer);
		_tsplitpath_s(szOrgFileName,NULL,0,NULL,0,NULL,0,Buffer,_MAX_EXT);
		Ext=Buffer;
	}
	else{
		switch(Type){
		case PARAMETER_GZ:
		case PARAMETER_BZ2:
			{
				TCHAR Buffer[_MAX_EXT+1];
				FILL_ZERO(Buffer);
				_tsplitpath_s(szOrgFileName,NULL,0,NULL,0,NULL,0,Buffer,_MAX_EXT);
				Ext=Buffer;
				Ext+=CompressParameterArray[Index].Ext;
			}
			break;
		case PARAMETER_JACK:
			//JACK̏ꍇɂ̓A[JCut@Co͐tH_ɂȂ
			//:t@CDLL
			break;
		default:
			Ext=CompressParameterArray[Index].Ext;
			break;
		}
	}
//	if(Options&COMPRESS_SPLIT){
//		Ext+=_T(".001");
//	}

	//o͐tH_
	TCHAR szOutputDir[_MAX_PATH+1]={0};
	if(NULL!=lpszSpecificOutputDir&&0!=_tcslen(lpszSpecificOutputDir)){
		//o͐tH_w肳Ăꍇ
		_tcsncpy_s(szOutputDir,lpszSpecificOutputDir,_MAX_PATH);
		TRACE(_T("OutputDir Specified:%s\n"),szOutputDir);
	}
	else{
		//ݒ肩o͐tH_Zo
		switch(Config.Common.Compress.OutputDirType){
		case COMPRESS_TO_DESKTOP:	//Desktop
			if(!SHGetSpecialFolderPath(NULL,szOutputDir,CSIDL_DESKTOPDIRECTORY,FALSE)){
				ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_GET_DESKTOP)));
				return false;
			}
			break;
		case COMPRESS_TO_SAME_DIR:	//Same Directory
			_tcsncpy_s(szOutputDir,szOrgFileName,_MAX_PATH);
			PathRemoveFileSpec(szOutputDir);
			break;
		case COMPRESS_TO_SPECIFIC_DIR:	//Specific Directory
			TRACE(_T("Specific Dir:%s\n"),Config.Common.Compress.OutputDir);
			if(0>=_tcslen(Config.Common.Compress.OutputDir)){
				//o͐悪ĂȂ΁AfXNgbvɏo͂
				if(!SHGetSpecialFolderPath(NULL,szOutputDir,CSIDL_DESKTOPDIRECTORY,FALSE)){
					ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_GET_DESKTOP)));
					return false;
				}
			}
			else{
				_tcsncpy_s(szOutputDir,Config.Common.Compress.OutputDir,_MAX_PATH);
			}
			break;
		case COMPRESS_TO_ALWAYS_ASK_WHERE:	//o͐𖈉񕷂
			TRACE(_T("Always ask\n"));
			{
				CString title(MAKEINTRESOURCE(IDS_INPUT_TARGET_FOLDER));
				CFolderDialog dlg(NULL,title,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
				if(IDOK==dlg.DoModal()){
					_tcsncpy_s(szOutputDir,dlg.GetFolderPath(),_MAX_PATH);
				}
				else{
					return false;
				}
			}
			break;
		default:	//ɂ͗Ȃ͂GłɃ`FbNς
			return false;
		}
	}

	PathAddBackslash(szOutputDir);

//========================
// t@C̐
//========================
	enum{
		STATUS_NOT_CHECKED,				//`FbNO;ftHg
		STATUS_OK,						//t@C͎gp\
		STATUS_FILE_ALREADY_EXISTS,		//kt@Cɑ
		STATUS_SAME_INPUT_AND_OUTPUT,	//͌Əo͐̃t@C
		STATUS_NETWORK,					//o͐̓lbg[NhCuł
		STATUS_REMOVABLE,				//o͐̓[oufBXNł
		STATUS_CANNOT_DECIDE_FILENAME	//t@CłȂ
	};

	int Status=STATUS_NOT_CHECKED;
//=================================================================================
// o͐悪lbg[NhCu/[oufBXNłȂAo͐I
//=================================================================================
	if(Config.Common.WarnNetwork||Config.Common.WarnRemovable){
		TCHAR Buffer[_MAX_PATH+1];
		FILL_ZERO(Buffer);
		_tcsncpy_s(Buffer,szOutputDir,_MAX_PATH);
		//[ghCupX擾
		PathStripToRoot(Buffer);

		switch(GetDriveType(Buffer)){
		case DRIVE_REMOVABLE://hCufBXN𔲂Ƃł܂B
		case DRIVE_CDROM://CD-ROM
			if(Config.Common.WarnRemovable){
				if(IDNO==MessageBox(NULL,CString(MAKEINTRESOURCE(IDS_ASK_ISOK_REMOVABLE)),UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
					Status=STATUS_REMOVABLE;
				}
			}
			break;

		case DRIVE_REMOTE://[g (lbg[N) hCułB
		case DRIVE_NO_ROOT_DIR:
			if(Config.Common.WarnNetwork){
				if(IDNO==MessageBox(NULL,CString(MAKEINTRESOURCE(IDS_ASK_ISOK_NETWORK)),UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
					Status=STATUS_NETWORK;
				}
			}
			break;
//			case DRIVE_NO_ROOT_DIR:
//				\\COM\Directorył̒lԂB
//				Status=STATUS_CANNOT_DECIDE_FILENAME;
//				break;
		}
	}
	if(STATUS_NOT_CHECKED==Status&&!PathIsDirectory(szOutputDir)){
		CString msg;
		//pX݂Ȃꍇ
		switch(Config.Common.OnDirNotFound){
		case LOSTDIR_ASK_TO_CREATE:	//쐬邩ǂ
			TRACE(_T("fBNg%s쐬mF\n"),szOutputDir);
			msg.Format(IDS_ASK_CREATE_DIR,szOutputDir);
			if(IDNO==MessageBox(NULL,msg,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
				TRACE(_T("-->쐬\n"));
				return false;
			}
			TRACE(_T("-->쐬\n"));
			//FALLTHROUGH
		case LOSTDIR_FORCE_CREATE:	//fBNg쐬
			TRACE(_T("fBNg%s쐬\n"),szOutputDir);
			if(!UtilMakeSureDirectoryPathExists(szOutputDir)){
				msg.Format(IDS_ERROR_CANNOT_MAKE_DIR,szOutputDir);
				ErrorMessage(msg);
				return false;
			}
			break;
		default://G[ƌȂ
			TRACE(_T("fBNg%s݂\n"),szOutputDir);
			msg.Format(IDS_ERROR_DIR_NOTFOUND,szOutputDir);
			ErrorMessage(msg);
			return false;
		}
	}
//============================
// A[JCut@Č
//============================
	if(PARAMETER_JACK==Type){
		//JACK؂􂫌`̏ꍇ͏o̓tH_w
		ArcFileName=szOutputDir;
		return true;
	}

	//t@CgqƃpX폜
	if(bDirectory){	//fBNg
		//fBNg͊gq(Ō'.'ȍ~̕)폜Ȃ
		TCHAR szFName[_MAX_PATH+1]={0};
		TCHAR szExt[_MAX_EXT+1]={0};
		_tsplitpath_s(szOrgFileName,NULL,0,NULL,0,szFName,_MAX_PATH,szExt,_MAX_EXT);

		//gqf[^ǉ
		Ext.Insert(0,szExt);

		ArcFileName.Empty();
		_tmakepath_s(ArcFileName.GetBuffer(_MAX_PATH*2),_MAX_PATH*2,NULL,szOutputDir,szFName,Ext);
		ArcFileName.ReleaseBuffer();
	}
	else{	//t@C
		TCHAR szFName[_MAX_PATH+1]={0};
		_tsplitpath_s(szOrgFileName,NULL,0,NULL,0,szFName,_MAX_PATH,NULL,0);

		ArcFileName.Empty();
		_tmakepath_s(ArcFileName.GetBuffer(_MAX_PATH*2),_MAX_PATH*2,NULL,szOutputDir,szFName,Ext);
		ArcFileName.ReleaseBuffer();
	}
	TRACE(_T("GetArchiveName:ArcFileName(b):%s\n"),ArcFileName);


	//---B2Eʈ
	if(PARAMETER_B2E==Type){
		return true;
	}

	//----------------------------
	// t@Cw肪K؂mF
	//----------------------------
	bool bForceOverwrite=false;
	bool bInputFilenameFirst=BOOL2bool(Config.Common.Compress.SpecifyOutputFilename);

	if(bDriveRoot){	//hCu[gkꍇAt@CłȂ
//		Status=STATUS_CANNOT_DECIDE_FILENAME;
		bInputFilenameFirst=true;
	}
	while(STATUS_OK!=Status){
		if(!bInputFilenameFirst){
			//==========================
			// t@CƂ
			//==========================
			if(ArcFileName.GetLength()>=_MAX_PATH){
				ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_MAX_PATH)));
				Status=STATUS_CANNOT_DECIDE_FILENAME;
			}

			//==========================================================
			// łt@C͌̃t@CƓǂ
			//==========================================================
			if(STATUS_NOT_CHECKED==Status||STATUS_FILE_ALREADY_EXISTS==Status){
				std::list<CString>::iterator ite,end;
				end=OrgFileNameList.end();
				for(ite=OrgFileNameList.begin();ite!=end;++ite){
					if(0==ArcFileName.CompareNoCase(*ite)){
						CString msg;
						msg.Format(IDS_ERROR_SAME_INPUT_AND_OUTPUT,ArcFileName);
						ErrorMessage(msg);
						Status=STATUS_SAME_INPUT_AND_OUTPUT;
						break;
					}
				}
			}

			//====================================================================
			// ΉDLLŃt@CUNICODEt@Ck悤Ƃ
			//====================================================================
			if(STATUS_NOT_CHECKED==Status&&!bUnicodeCapable&&!UtilCheckT2A(ArcFileName)){
				ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_UNICODEPATH)));
				Status=STATUS_CANNOT_DECIDE_FILENAME;
			}

			//================================
			// t@Cɑ݂邩ǂ
			//================================
			if(STATUS_NOT_CHECKED==Status&&!bForceOverwrite){
				if(PathFileExists(ArcFileName)){
					// t@C݂肠
					// ̏ꍇ̓G[bZ[WoɃt@C͂
					Status=STATUS_FILE_ALREADY_EXISTS;
				}
			}

			//============================================================
			// ܂ł̃`FbNɂt@CłȂƂꂽꍇ
			//============================================================
			if(STATUS_NOT_CHECKED==Status){
				// ɃN[tȂOKƂƁB
				Status=STATUS_OK;
			}
		}

		//`FbNς
		if(!bInputFilenameFirst&&STATUS_OK==Status){
			break;
		}
		else{
			//==================
			// Otĕۑ
			//==================

			//tB^񐶐
			CString strFilter(MAKEINTRESOURCE(IDS_COMPRESS_FILE));
			strFilter.AppendFormat(_T(" (*%s)|"),Ext);
			strFilter.AppendFormat(_T("*%s"),Ext);
			TCHAR filter[_MAX_PATH+2]={0};
			UtilMakeFilterString(strFilter,filter,sizeof(filter)/sizeof(filter[0]));

			//ŏ̃t@Ĉ͉g
			//Iꂽt@CԂĂ
			TCHAR szFilePath[_MAX_PATH+1]={0};
			if(STATUS_CANNOT_DECIDE_FILENAME==Status){
				//t@CłȂꍇAJgfBNgspXƂ
				TCHAR szBuffer[_MAX_PATH+1]={0};
				GetCurrentDirectory(_MAX_PATH,szBuffer);
				_tmakepath_s(szFilePath,_MAX_PATH,NULL,szBuffer,CString(MAKEINTRESOURCE(IDS_UNTITLED)),Ext);
			}
			else{
				_tcsncpy_s(szFilePath,ArcFileName,_MAX_PATH);
			}
			CFileDialog dlg(FALSE, Ext, szFilePath, OFN_OVERWRITEPROMPT|OFN_NOCHANGEDIR,filter);
			if(IDCANCEL==dlg.DoModal()){	//LZ
				return false;
			}

			//t@C̃OpX擾
			TCHAR szBuffer[_MAX_PATH+1];
			_tcsncpy_s(szBuffer,dlg.m_szFileName,_MAX_PATH);
			GetLongPathName(szBuffer,szBuffer,_MAX_PATH);
			ArcFileName=szBuffer;
			TRACE(_T("SaveFileName:")),TRACE(ArcFileName),TRACE(_T("\n"));

			bForceOverwrite=true;
			Status=STATUS_NOT_CHECKED;
			bInputFilenameFirst=false;
		}
	}
	return true;
}


int CountFileToCompress(LPCTSTR Path,CString &FileName)
{
	if(!PathIsDirectory(Path)){	//pXt@C̏ꍇ
		FileName=Path;
		return 1;
	}
	else{	//pXtH_̏ꍇAtH_̃t@CT
		int FileCount=0;
		WIN32_FIND_DATA lp;

		CString Buffer=Path;
		Buffer+=_T("\\*");
		HANDLE h=FindFirstFile(Buffer,&lp);

		do{
			if((lp.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)&& 0!=_tcscmp(lp.cFileName,_T("..")) && 0!=_tcscmp(lp.cFileName,_T(".")))
			{
				CString SubPath=Path;
				SubPath+=_T("\\");
				SubPath+=lp.cFileName;

				FileCount+=CountFileToCompress(SubPath,FileName);
				if(FileCount>=2){
					FindClose(h);
					return 2;
				}
			}
			if((lp.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=FILE_ATTRIBUTE_DIRECTORY)
			{
				// lp.cFileNameŃt@C
				// wsprintf(o͕,"%s%s",temp,lp.cFileName);Ƃ
				// t@C̃tpX
				FileName=Path;
				FileName+=_T("\\");
				FileName+=lp.cFileName;

				FileCount++;
				if(FileCount>=2){
					FindClose(h);
					return 2;
				}
			}
		}while(FindNextFile(h,&lp));
		FindClose(h);
		return FileCount;
	}
}

bool B2ECompress(std::list<CString> &ParamList,CConfigManager &Config,LPCTSTR lpszSpecificOutputFileName,LPCTSTR lpszSpecificOutputDir,LPCTSTR lpszFormat,LPCTSTR lpszMethod,bool bSFX)
{
	TRACE(_T("Function ::B2ECompress() started.\n"));

	ASSERT(lpszFormat);
	ASSERT(lpszMethod);

	CArchiverDLLManager &ArchiverManager=CArchiverDLLManager::GetInstance();
	Config.LoadConfig(CONFIG_COMMON);
	Config.LoadConfig(CONFIG_B2E);

	//B2E32.dll̃nh擾
	CArchiverB2E &Archiver=ArchiverManager.GetB2EHandler();
	if(!Archiver.IsOK()){
		//B2E32.dll݂Ȃ
		return false;
	}

	//=========================================================
	// JgfBNgݒ̂߂\ŏI_pX擾
	//=========================================================
	CString BasePath;
	UtilGetBaseDirectory(BasePath,ParamList);
	TRACE(BasePath),TRACE(_T("\n"));

	//JgfBNgݒ
	SetCurrentDirectory(BasePath);

	//kt@C(gq'.archive'ɂȂĂ;B2EŏɏC)
	TRACE(_T("kt@C\n"));
	CString ArcFileName;
	if(!GetArchiveName(ArcFileName,ParamList,PARAMETER_B2E,bSFX?COMPRESS_SFX:0,Config,lpszSpecificOutputFileName,lpszSpecificOutputDir,Archiver.IsUnicodeCapable())){
		//ErrorMessage
		return false;
	}

	//====================================================================
	// ΉDLLŃt@CUNICODEt@Ck悤Ƃ
	//====================================================================
	if(!Archiver.IsUnicodeCapable()&&!UtilCheckT2A(ArcFileName)){
		//GetArchiveNameŒe؂Ȃ̂Œe
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_UNICODEPATH)));
		return false;
	}

	//======================================
	// X|Xt@CɋL邽߂
	// kΏۃt@CC
	//======================================
	const int BasePathLength=BasePath.GetLength();
	std::list<CString>::iterator ite;
	for(ite=ParamList.begin();ite!=ParamList.end();++ite){
		//x[XpXɑ΃pX擾 : ʂłpX̕Jbg
		(*ite).Delete(0,BasePathLength);

		//BasePathƓɂȂċɂȂĂ܂pX΁AJgfBNgwɓĂ
		if((*ite).IsEmpty()){
			*ite=_T(".");
		}
	}

	//--------------------------------
	//---A[JCu͍폜Ȃ---
	//--------------------------------
/*	CFindFile cFindFile;
	if(cFindFile.FindFile(ArcFileName)){	//o̓t@CɖO̗ގt@C
	}*/

	//Z}tHɂr
	CSemaphoreLocker SemaphoreLock;
	if(Config.Common.Compress.LimitCompressFileCount){
		SemaphoreLock.Lock(LHAFORGE_COMPRESS_SEMAPHORE_NAME,Config.Common.Compress.MaxCompressFileCount);
	}


	TRACE(_T("ArchiverHandler Ăяo\n"));
	//------------
	// ks
	//------------
	CString strLog;
	bool bRet=Archiver.B2ECompress(ArcFileName,ParamList,Config,lpszFormat,lpszMethod,bSFX,strLog);
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(!bRet){
			CLogDialog LogDlg;
			LogDlg.SetData(strLog);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(strLog);
		LogDlg.DoModal();
		break;
	}

	//o͐tH_J
	if(bRet&&Config.Common.Compress.OpenDir){
		TCHAR Buffer[_MAX_PATH+1];
		FILL_ZERO(Buffer);
		_tcsncpy_s(Buffer,ArcFileName,_MAX_PATH);
		PathRemoveFileSpec(Buffer);
		if(!Config.Common.Filer.UseFiler){
			TCHAR ExplorerPath[_MAX_PATH+1];
			FILL_ZERO(ExplorerPath);
			GetWindowsDirectory(ExplorerPath,_MAX_PATH);
			PathAppend(ExplorerPath,_T("Explorer.exe"));
			ShellExecute(NULL, _T("open"), ExplorerPath, Buffer, NULL, SW_SHOWNORMAL);
		}else{
			PathQuoteSpaces(Buffer);
			CString Param=Config.Common.Filer.Param;
			Param.Replace(_T("{dir}"),Buffer);
			ShellExecute(NULL, _T("open"), Config.Common.Filer.FilerPath,Param, NULL, SW_SHOWNORMAL);
		}
	}

	TRACE(_T("Exit B2ECompress()\n"));
	return bRet;
}

